SystemOrganization addCategory: #SVO!
SystemOrganization addCategory: 'SVO-Announcements'!
SystemOrganization addCategory: 'SVO-Commands'!
SystemOrganization addCategory: 'SVO-Parser'!
SystemOrganization addCategory: 'SVO-Slots'!
SystemOrganization addCategory: 'SVO-Slots-VO'!
SystemOrganization addCategory: 'SVO-Tests'!
SystemOrganization addCategory: 'SVO-UI-App'!
SystemOrganization addCategory: 'SVO-UI-SVO'!
SystemOrganization addCategory: 'SVO-Utilities'!

DynamicComposableModel subclass: #ActionSlotUI
	instanceVariableNames: 'button source result model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!ActionSlotUI commentStamp: 'hk 2/2/2015 21:05' prior: 0!
A DslMethodUI is thew developer UI for a user action button using DSL.

Instance Variables
	button:		<ButtonModel >
	result:		<LabelModel >
	source:		<TextInputFieldModel >
	model:

!

!ActionSlotUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 21:06'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 15:49'!
button
	^ button! !

!ActionSlotUI methodsFor: 'ui-actions' stamp: 'hk 12/3/2014 15:50'!
exec
	model source: source text. 
	result label: model exec! !

!ActionSlotUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 21:20'!
height
	^ self singleHeight * 2! !

!ActionSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:30'!
initializeLayout
	"(ActionSlotUI on: ActionSlot new) openWithSpec"
	"(CommonSlotUI on: ActionSlot new type: ActionSlotUI) openWithSpec"

	self layout: (SpecLayout composed
		newColumn: [ :clmn | 
			clmn newRow: [ :r | 
					r add: #source.
					r add: #button width: self class buttonWidth ]
				height: self singleHeight.
			clmn add: #result ])! !

!ActionSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:06'!
initializeWidgets
	"(DslMethodUI on: DslActionSlotValue new) openWithSpec"
	source := (self newTextInput)
						autoAccept: true;
						ghostText: 'undefined'.
	source text: model source	.				
	result := (self newLabel) text: 'no result' .
	button := self newButton.
	button
		label: 'exec';
		action: [ self exec ];
		state: true.
	self initializeLayout! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 21:09'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 21:09'!
model: aSlot
	model := aSlot! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 15:50'!
result
	^ result! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 12/5/2014 10:52'!
save
	model source: source text! !

!ActionSlotUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 21:20'!
singleHeight
	^ self class toolbarHeight ! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 15:48'!
source
	^ source! !

DynamicComposableModel subclass: #CommonSlotUI
	instanceVariableNames: 'key kill model up down forDisplay type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!CommonSlotUI commentStamp: 'hk 2/2/2015 15:18' prior: 0!
A SpoAbstractSlotUI is xxxxxxxxx.

Instance Variables
	down:		<ButtonModel>
	key:		<LabelModel >
	kill:			<ButtonModel>
	model:		<Slot>
	up:			<ButtonModel >
	type: 		<SlotUI>
	forDisplay: 	<CheckBoxModel>!

!CommonSlotUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 17:08'!
on: aSlot
	^self on: aSlot type: nil! !

!CommonSlotUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 15:15'!
on: aSlot type: aSlotUI
	^self basicNew model: aSlot; type: aSlotUI; initialize! !

!CommonSlotUI methodsFor: 'ui-helpers' stamp: 'hk 12/2/2014 17:07'!
doubleHeight
	^2 * self singleHeight! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
down
	^ down! !

!CommonSlotUI methodsFor: 'ui-actions' stamp: 'hk 12/15/2014 21:28'!
downAction
	owner isListEditor ifFalse: 
		[ model index < model maxIndex ifTrue: [ self exec: MoveDown ] ]! !

!CommonSlotUI methodsFor: 'private' stamp: 'hk 12/10/2014 17:47'!
exec: aCommand
	"Example : kontakt exec:  (MoveUp named: #vorname) "
	model frame exec: (aCommand named: model key )  ! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 1/20/2015 17:34'!
forDisplay
	^ forDisplay! !

!CommonSlotUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 18:54'!
height
	^self singleHeight max:  self typeHeight  ! !

!CommonSlotUI methodsFor: 'initialization' stamp: 'hk 12/1/2014 13:18'!
initialExtent
	"(4@4) is the size of the border"

	^ 400 @ (40 + self height) + (4 @ 4)! !

!CommonSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:12'!
initializeLayout
	"(CommonSlotUI on: AbstractSlot new ) openWithSpec"
	
	type ifNotNil: [ self assign: (type on: self model) to: #type ].
	self layout: (SpecLayout composed
		newRow: [ :row | 
				row add: #key width: 125. 
				row	add: #forDisplay width: 20 .
				type ifNotNil: [row add: #type] .
				row add:  #up width: 20 ;  
					add: #down width: 20 ;
				 	add: #kill width: 20 ] ) ! !

!CommonSlotUI methodsFor: 'initialization' stamp: 'hk 1/20/2015 17:35'!
initializeWidgets
	"(AbstractSlotUI on: AbstractSlot new) openWithSpec"
	
	key := (self newLabel) text: model key; yourself .
	(forDisplay := self newCheckBox) 
		state: model forDisplay.
	(kill := self newButton)
		label: 'X';
		action: [self killAction];
		state: true;
		yourself.
	(up := self newButton)
		label: '<';
		action: [self upAction ];
		state: true;
		yourself.
	(down := self newButton)
		label: '>';
		action: [self downAction ];
		state: true;
		yourself.
	self initializeLayout 
! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
key
	^ key! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
kill
	^ kill! !

!CommonSlotUI methodsFor: 'ui-actions' stamp: 'hk 1/26/2015 22:29'!
killAction
	self owner isListEditor 
		ifTrue: [ self exec:  RemoveSvoCopy ]
		ifFalse: [ self exec: RemoveSlot ]! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:06'!
model
	^model ! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
model: anObject
	model := anObject! !

!CommonSlotUI methodsFor: 'ui-actions' stamp: 'hk 2/2/2015 21:43'!
save
	model forDisplay: forDisplay state.
	type ifNotNil: [ self typeWidget save ]! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 12/1/2014 12:49'!
singleHeight
	^self class toolbarHeight	
	! !

!CommonSlotUI methodsFor: 'initialization' stamp: 'hk 11/27/2014 19:11'!
specFor: row
	"plug-in for subclasses"! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 15:16'!
type: aSlotUI
	type := aSlotUI! !

!CommonSlotUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 18:57'!
typeHeight
	| w |
	w := self widgets at: #type ifAbsent: [ ^0 ] .
	(w respondsTo: #height) ifFalse: [ ^0 ].
	^w height ! !

!CommonSlotUI methodsFor: 'as yet unclassified' stamp: 'hk 2/2/2015 21:42'!
typeWidget
	^self widgets at: #type ifAbsent: [ nil ]! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
up
	^ up! !

!CommonSlotUI methodsFor: 'ui-actions' stamp: 'hk 12/15/2014 21:29'!
upAction
	owner isListEditor ifFalse: 
		[ model index > 1 ifTrue: [self exec: MoveUp ] ]! !

DynamicComposableModel subclass: #DropListUI
	instanceVariableNames: 'list model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!DropListUI commentStamp: 'hk 2/2/2015 17:22' prior: 0!
A SlotListUI is xxxxxxxxx.

Instance Variables
	list:		<ListModel >
	model:	<DropList>!

!DropListUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 17:27'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!DropListUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:33'!
initializeLayout
	"(DropListUI on: DropListSlot new) openWithSpec"
	"(CommonSlotUI on: DropListSlot new type: DropListUI) openWithSpec"
	
	self layout: (SpecLayout composed
		newColumn: [ :c | c add: #list ] )! !

!DropListUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 17:22'!
initializeWidgets
	"(DropListUI on: (DropListSlot new list: #(#a #b #c); key: #bla )) openWithSpec"
	list := self newDropList .
	list items: model list .
	list setSelectedItem: model selection.
	self initializeLayout ! !

!DropListUI methodsFor: 'accessing' stamp: 'hk 11/28/2014 16:44'!
list
	^ list! !

!DropListUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:25'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!DropListUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:25'!
model: aSlot
	model := aSlot! !

!DropListUI methodsFor: 'ui-actions' stamp: 'hk 2/2/2015 17:25'!
save
	model selection: list selectedItem! !

DynamicComposableModel subclass: #DslValueSlotUI
	instanceVariableNames: 'source button label slotValue model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!DslValueSlotUI commentStamp: 'hk 2/2/2015 21:05' prior: 0!
A SlotEmbeddedValueUI is a developer UI for a slot, individually copied from another SPO by DSL.

Instance Variables
	button:		<ButtonModel >
	label:		<LabelModel>
	source:		<String>
	slotValue:		<LabelModel >
	model:!

!DslValueSlotUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 20:54'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:02'!
button
	^ button! !

!DslValueSlotUI methodsFor: 'ui-actions' stamp: 'hk 12/2/2014 19:04'!
exec
	model source: source text.
	model exec.
	label label: model originalKey.
	slotValue label: model value
	! !

!DslValueSlotUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 20:59'!
height
	^self class toolbarHeight * 2 
	! !

!DslValueSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:31'!
initializeLayout
	"(DslValueSlotUI on: DslValueSlot new) openWithSpec"
	
	self layout: (SpecLayout composed
		newColumn: [ :c | 
			c newRow:  [ :r |  r add: #source ; add: #button 
					width: self class buttonWidth] .
			c newRow: [ :r | r add: #label; add: #slotValue] ] )
	
	! !

!DslValueSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 20:57'!
initializeWidgets
	(label := self newLabel) label: model originalKey .
	(slotValue := self newLabel) label: model value . 
	source := (self newTextInput)
						autoAccept: true;
						ghostText: 'undefined'.
	source text: model source.
	(button := self newButton)
		label: 'exec';
		action: [ self exec ];
		state: true.
	self initializeLayout
	! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:03'!
label
	^ label! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 20:54'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 20:54'!
model: aSlot
	model := aSlot! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/5/2014 10:54'!
save
	model source: source text! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 19:05'!
slotValue
	^ slotValue! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:02'!
source
	^ source! !

DynamicComposableModel subclass: #GloConnMainUI
	instanceVariableNames: 'model loginName login password logout loginLabel loginNameLabel height menu lastCommand headerButton mainContext processContext'
	classVariableNames: 'icons'
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnMainUI commentStamp: 'hk 2/3/2015 11:54' prior: 0!
I am the app main window model

Instance Variables
	headerButton:		<ButtonModel>				GloConn header
	height:				<Numbert>
	lastCommand:		<Symbol | nil>				nil before login
	login:				<ButtonModel>
	loginLabel:			<LabelModel>
	loginName:			<TextInputFieldModel>
	loginNameLabel:	<LabelModel>
	logout:				<ButtonModel>
	menu:				<MenuModel>				main menu
	model:				<CF>						main context
	password:			<TextInputFieldModel>
	mainContext:		<Object>
	processContext:	<Object>

!

!GloConnMainUI class methodsFor: 'icons' stamp: 'hk 1/26/2015 16:18'!
initializeIcons
	"self initializeIcons"
	icons := Dictionary new.
	icons at: #bizNet put: ( ColorForm fromFileNamed: 'Icons/bizNet.gif' ).
	icons at: #bizProcess put: ( ColorForm fromFileNamed: 'Icons/bizProcess.gif' ).
	icons at: #calc put: ( ColorForm fromFileNamed: 'Icons/calc.gif' ).
	icons at: #contacts put: ( ColorForm fromFileNamed: 'Icons/contacts.gif' ).
	icons at: #controlling put: ( ColorForm fromFileNamed: 'Icons/controlling.gif' ).
	icons at: #dash put: ( ColorForm fromFileNamed: 'Icons/dash.gif' ).
	icons at: #dashboard put: ( ColorForm fromFileNamed: 'Icons/dashboard.gif' ).
	icons at: #header put: ( ColorForm fromFileNamed: 'Icons/header.gif' ).
	icons at: #mail put: ( ColorForm fromFileNamed: 'Icons/mail.gif' ).
	icons at: #processes put: ( ColorForm fromFileNamed: 'Icons/process.gif' ).
	icons at: #route put: ( ColorForm fromFileNamed: 'Icons/route.gif' ).
	icons at: #settings put: ( ColorForm fromFileNamed: 'Icons/settings.gif' ).
	icons at: #tour put: ( ColorForm fromFileNamed: 'Icons/tour.gif' ).
	icons at: #tourSub put: ( ColorForm fromFileNamed: 'Icons/tourSub.gif' ).
	icons at: #tourPlan put: ( ColorForm fromFileNamed: 'Icons/tourPlan.gif' ).
	icons at: #user put: ( ColorForm fromFileNamed: 'Icons/user.gif' ).
	! !

!GloConnMainUI class methodsFor: 'instance creation' stamp: 'hk 1/27/2015 12:29'!
on: aMcf
	^ self basicNew
		mainContext: aMcf;
		initialize;
		yourself! !

!GloConnMainUI class methodsFor: 'instance creation' stamp: 'hk 1/27/2015 10:43'!
onM: aMcf onP: aPcf
	^ self basicNew
		mainContext: aMcf;
		processContext: aPcf;
		initialize;
		yourself! !

!GloConnMainUI class methodsFor: 'instance creation' stamp: 'hk 1/24/2015 17:56'!
title
    ^ ''! !

!GloConnMainUI methodsFor: 'private' stamp: 'hk 1/26/2015 10:27'!
ableMainButtonMenu: aBoolean 	
	menu menuGroups do: [ :g |
		g menuItems do: [ :m | m enabled: aBoolean ] ]  ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 15:57'!
addBizNetButtonGroup:g  	
			g addItem: [  :i | i
				icon: (icons at: #bizProcess) ;
				description: 'show biz processes' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (icons at: #bizNet) ;
				description: 'show biz net' ;
				action: [  ] ] ! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/27/2015 10:56'!
addCalc: aColumn 
	self addIconRow:  #calc label: 'Calculator' to: aColumn .
	aColumn add: #emptyLabel ;
			newRow: [ :r | r  
				add: #emptyLabel ;
				add: #calculator  ;
				add: #emptyLabel ] height: 6.333 * self singleHeight ;
			add: #emptyLabel ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 16:08'!
addCommunicationButtonGroup:g	
			g addItem: [  :i | i
				icon: (icons at: #contacts) ;
				description: 'show contacts' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (icons at: #route) ;
				description: 'show route planning' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (icons at: #mail );
				description: 'show mail' ;
				action: [  ] ]  ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 15:59'!
addControllingButtonGroup:g 	
			g addItem: [  :i | i
				icon: (icons at: #controlling) ;
				description: 'show controlling' ;
				action: [  ] ] ! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 2/3/2015 12:04'!
addDashboard: aColumn 
	self addIconRow:  #dash label: 'Dashboard' to: aColumn .
	self addPaneMenu: aColumn .
	aColumn add: #dashButton ! !

!GloConnMainUI methodsFor: 'private' stamp: 'hk 1/27/2015 12:36'!
addIconRow: anIcon label: aString to: aColumn 
	(self widgets at: #dashLabel) text: aString .
	aColumn newRow: [ :r | r
		add:  anIcon width: 24 ;
		add:  #dashLabel  ] height: self singleHeight! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/25/2015 15:28'!
addLogin: aRow
	aRow	add: #loginLabel width: 120;
			add: #loginNameLabel width: 160;
			add: #logout width: 80! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/25/2015 15:28'!
addLoginRow: aColumn
	aColumn newRow: [ :r | 
			r add: #emptyLabel.
			self loginName text isEmpty
				ifTrue: [ self addLogout: r ]
				ifFalse: [ self addLogin: r ] ]
		height: self singleHeight.
	height := height + self singleHeight! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/25/2015 15:26'!
addLogo: aColumn
	aColumn add: #emptyButton height: 150.
	aColumn addSplitter.
	height := height + 150! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/25/2015 15:29'!
addLogout: aRow
	aRow	add: #loginName width: 120;
			add: #password width: 120;
			add: #login width: 80! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/25/2015 15:41'!
addMainButtons: aColumn
	aColumn add: #menu height: self singleHeight.
	height := height + self singleHeight ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 2/3/2015 11:49'!
addMenuGap: g	
	 g addItem: [ :i | 
		i icon: (Smalltalk ui icons blankIconOfWidth: 144) ] ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 16:08'!
addMiscellaneousButtonGroup: g
	g	addItem: [ :i | i
				icon: (icons at: #calc) ;
				description: 'calculator';
				action: [ self calcAction ] ].
	g	addItem: [ :i | i
				icon: (icons at: #settings) ;
				description: 'settings';
				action: [  ] ].
	g	addItem: [ :i | i
				icon: (icons at: #user) ;
				description: 'show user data';
				action: [  ] ]! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 2/3/2015 14:09'!
addPane: aColumn 
	lastCommand ifNil: 
		[ aColumn add: #paneButton ].
	(lastCommand = #dashboard) ifTrue: [ self addDashboard: aColumn  ].
	(lastCommand = #processes) ifTrue: [ self addProcesses: aColumn  ].
	(lastCommand = #calc) ifTrue: [ self addCalc: aColumn ] .
	height := height + 650 ! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 2/4/2015 17:41'!
addPaneMenu: aColumn 
	"build the pane contexts own menu with a little help by the ROs"
	| m paneUI |
	paneUI := (self widgets at: #bizprocesses).
	(m := MenuModel new) addGroup: [ :g | 
			model roles do: [ :ro |  
				ro hasMenu ifTrue: 
					[ g addMenuItem: (ro menu: [ self reOpen ]) ] ] ] . 
				
	self assign: m to: #dynamicMenu .
	aColumn add: #dynamicMenu height: self singleHeight ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/27/2015 12:39'!
addProcessButtonGroup: g 	
			g addItem: [  :i | i
				icon: (icons at: #dash) ;
				description: 'show dash board' ;
				action: [ self dashboardAction ] ] .
			g addItem: [  :i | i
				icon: (icons at: #processes) ;
				description: 'show biz processes' ;
				action: [ self processAction  ] ] ! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 2/5/2015 13:47'!
addProcesses: aColumn 

	self addIconRow:  #processes label: 'Biz Processes' to: aColumn .
	self addPaneMenu: aColumn .	
	aColumn add: #bizprocesses  .
	(self widgets at: #bizprocess ifAbsent: [ ] ) ifNotNil: [ aColumn add: #bizprocess ] .
	aColumn add: #emptyLabel .
! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 16:07'!
addTourButtonGroup: g 	
			g addItem: [  :i | i
				icon: (icons at: #tourPlan) ;
				description: 'show transport planning' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (icons at: #tour) ;
				description: 'show tour planning' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (icons at: #tourSub) ;
				description: 'show subcontracts' ;
				action: [  ] ] ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/27/2015 13:00'!
assignWidgets
	self assign: (ButtonModel new icon: (icons at: #dash)) to: #dash.
	self assign: (ButtonModel new icon: (icons at: #processes)) to: #processes.
	self assign: (LabelModel new text: 'Dashboard' ) to: #dashLabel .
	self assign: (ButtonModel new icon: (icons at: #calc)) to: #calc.
	self assign: (LabelModel new text: '' ) to: #emptyLabel . "shifts login to the right"
	"the empty pane"
	self assign: (ButtonModel new state: false; label: 'please login') to: #paneButton.
	"the dashboard surrogate"
	self assign: (ButtonModel new state: false; icon: (icons at: #dashboard)) to: #dashButton.  

! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 2/3/2015 11:40'!
buildColumn: aColumn
	self addLogo: aColumn.
	self addLoginRow: aColumn.
	self addMainButtons: aColumn .

	self addPane: aColumn .

! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 1/25/2015 20:14'!
calcAction
	lastCommand := #calc .
	self reOpen ! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 1/27/2015 10:45'!
dashboardAction
	lastCommand := #dashboard .
	self model: mainContext .
	self reOpen ! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/25/2015 20:02'!
emptyButton
	^ headerButton! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/25/2015 15:11'!
fullWidth
	^ 1200 +4! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/24/2015 18:21'!
height
	^height ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/25/2015 11:20'!
initialExtent
	^ self fullWidth  @ self height ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 16:02'!
initializeHeader
	(headerButton := self newButton ) 
		icon: (icons at: #header) ;
		state: false 
! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 2/5/2015 13:52'!
initializeLayout
	"(GloConnMainUI on: (CF new: #bla)  ) openWithSpec"

	"assign all widgets to be dynamically plugged"
	| listUI |
	self assign: SvoCalc new to: #calculator .	
	listUI := (SvoListUI on: self processContext) editBlock: 
		[ :s | self processContext subContext: (CFplain new vo: s) .
			  self assign: (SvoSpecUI on: s)  to: #bizprocess .
			  self reOpen ] .
	self assign: listUI to: #bizprocesses.

	height := self singleHeight .
	self layout: (SpecLayout composed newColumn: [ :c | self buildColumn: c ] ).
	self needFullRebuild: false.
! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/24/2015 18:42'!
initializeLoginHeader
	(login := self newButton ) 
		label: 'login' ;
		action: [ self loginAction ] ;
		state: true .
	(loginName := self newTextInput )
		autoAccept: true ;
		ghostText: 'login name'  .
	(password := self newTextInput )
		autoAccept: true ;
		ghostText: 'password' .! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/24/2015 18:52'!
initializeLogoutHeader
	(logout := self newButton ) 
		label: 'logout' ;
		action: [ self logoutAction ] ;
		state: true .
	(loginLabel := self newLabel )
		text: 'Eingeloggt als '  .
	(loginNameLabel := self newLabel )
		text: self loginName text .! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 10:28'!
initializeMainButtonMenu 	
	(menu := MenuModel new) addGroup: [ :g |
		self addProcessButtonGroup: g .
		self addMenuGap: g .
		self addTourButtonGroup: g .
		self addMenuGap: g .
		self addControllingButtonGroup: g .
		self addMenuGap: g .
		self addCommunicationButtonGroup: g .
		self addMenuGap: g .
		self addBizNetButtonGroup: g .
		self addMenuGap: g .
		self addMiscellaneousButtonGroup: g ].
	self ableMainButtonMenu: false! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 2/4/2015 17:51'!
initializeWidgets
	self initializeHeader.
	self initializeLoginHeader.
	self initializeLogoutHeader.
	self assignWidgets  .
	self initializeMainButtonMenu .
	self initializeLayout ! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 17:47'!
login
	^ login! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 1/26/2015 10:57'!
login:  aString  password: anotherString 
	 ^aString isNotEmpty ! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 1/26/2015 10:38'!
loginAction
	loginNameLabel text:  loginName text.
	(self login: loginName text password: password text)
		ifFalse: [ ^self logoutAction  ].
	self ableMainButtonMenu: true .
	self dashboardAction  ! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 17:38'!
loginLabel
	^ loginLabel! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 17:37'!
loginName
	^ loginName! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 17:38'!
loginNameLabel
	^ loginNameLabel! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 17:38'!
logout
	^ logout! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 1/26/2015 10:44'!
logoutAction
	loginName text: '' .
	password text: '' .
	lastCommand := nil .
	self ableMainButtonMenu: false .
	self reOpen ! !

!GloConnMainUI methodsFor: 'accessing cf' stamp: 'hk 1/27/2015 13:11'!
mainContext
	^mainContext! !

!GloConnMainUI methodsFor: 'accessing cf' stamp: 'hk 1/27/2015 10:41'!
mainContext: aCF
	mainContext := aCF! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/25/2015 15:41'!
menu
	^ menu! !

!GloConnMainUI methodsFor: 'accessing cf' stamp: 'hk 1/24/2015 17:37'!
model: aCF
	model := aCF! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 17:47'!
password
	^ password! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 1/27/2015 12:39'!
processAction
	lastCommand := #processes .
	self model: processContext .
	self reOpen ! !

!GloConnMainUI methodsFor: 'accessing cf' stamp: 'hk 1/27/2015 13:10'!
processContext
	^processContext ! !

!GloConnMainUI methodsFor: 'accessing cf' stamp: 'hk 1/27/2015 10:42'!
processContext: aCF
	processContext := aCF! !

!GloConnMainUI methodsFor: 'private' stamp: 'hk 1/24/2015 17:43'!
reOpen
	self initializeLayout; openWithSpec
! !

!GloConnMainUI methodsFor: 'layout' stamp: 'hk 1/24/2015 18:18'!
singleHeight
	^self class toolbarHeight ! !

DynamicComposableModel subclass: #SvoCalc
	instanceVariableNames: 'display button0 button1 button2 button3 button4 button5 button6 button7 button8 button9 buttonPlus buttonMinus buttonMult buttonDiv buttonEq buttonDot buttonSqr buttonLog buttonChange buttonClear previousNumber currentOperation operationPending'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Utilities'!

!SvoCalc commentStamp: 'hk 11/6/2014 18:58' prior: 0!
A SpoCalc is the Spec Demo Calculator enhanced.

Instance Variables
	display:				<TextInput>	the calculators input & display
	currentOperation:	<String>		the operation to be performed:  +  -  * / 
	operationPending:	<Bolean>		true after pressing +  -  * /  =
										means: new input expected
	previousNumber:	<Number | nil>	stores the first value entered
										no operation pending ifNil
			
	button0:			<Button>
	button1:			<Button>
	button2:			<Button>
	button3:			<Button>
	button4:			<Button>
	button5:			<Button>
	button6:			<Button>
	button7:			<Button>
	button8:			<Button>
	button9:			<Button>
	buttonChange:		<Button>
	buttonClear:		<Button>
	buttonDiv:			<Button>
	buttonDot:			<Button>
	buttonEq:			<Button>
	buttonLog:			<Button>
	buttonMinus:		<Button>
	buttonMult:			<Button>
	buttonPlus:			<Button>
	buttonSqr:			<Button>

!

!SvoCalc class methodsFor: 'specs' stamp: 'hk 1/21/2015 16:02'!
example
	"SvoCalc example"

	SvoCalc new openWithSpec! !

!SvoCalc class methodsFor: 'specs' stamp: 'hk 1/5/2015 14:43'!
title 
	^ 'SVO Calculator'! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:01'!
addition
	buttonPlus
		label: '+';
		action: [ self operation: $+ ];
		state: true! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
button0
	^ button0! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
button1
	^ button1! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button2
	^ button2! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button3
	^ button3! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button4
	^ button4! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button5
	^ button5! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button6
	^ button6! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button7
	^ button7! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button8
	^ button8! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button9
	^ button9! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonChange
	^ buttonChange! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonClear
	^ buttonClear! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
buttonDiv
	^ buttonDiv! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonDot
	^ buttonDot! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonEq
	^ buttonEq! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonLog
	^ buttonLog! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonMinus
	^ buttonMinus! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
buttonMult
	^ buttonMult! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonPlus
	^ buttonPlus! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonSqr
	^ buttonSqr! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 18:02'!
changeSign
	buttonChange
		label: '+/ -';
		action: [ display label: display label asNumber negated asString ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 16:13'!
clearDisplay
	buttonClear
		label: 'C';
		action: [ display label: '0' ];
		state: true! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 14:56'!
defineDigitButton: aButton label: aString
	aButton
		label: aString;
		action: [ display label: (self newDisplayLabelFor: aString) asNumber asString  ];
		state: true! !

!SvoCalc methodsFor: 'button definition' stamp: 'hk 11/6/2014 14:57'!
defineDigitButtons
	button0
		label: '0' ;
		action: [ display label: (self newDisplayLabelFor: '0' )  ];
		state: true.
	self defineDigitButton: button1 label: '1'.
	self defineDigitButton: button2 label: '2'.
	self defineDigitButton: button3 label: '3'.
	self defineDigitButton: button4 label: '4'.
	self defineDigitButton: button5 label: '5'.
	self defineDigitButton: button6 label: '6'.
	self defineDigitButton: button7 label: '7'.
	self defineDigitButton: button8 label: '8'.
	self defineDigitButton: button9 label: '9'.
! !

!SvoCalc methodsFor: 'button definition' stamp: 'hk 11/5/2014 14:45'!
defineOtherButtons
	"basic arithmetic operations"
	self addition.
	self subtraction.
	self multiplication.
	self division.	
		
	"other arithmetic opertions"
	self squareRoot.
	self logarithm.
	self changeSign.	
		
	"remaining buttons"
	self clearDisplay.
	self enterDot.
	self equals! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:34'!
display
	^ display! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:06'!
division
	buttonDiv
		label: '/';
		action: [ self operation: $/ ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 15:56'!
enterDot
	buttonDot
		label: '.';
		action: [display label: (self newDisplayLabelForDot )  ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 16:12'!
equals
	buttonEq
		label: '=';
		action: [ operationPending := true. 
				previousNumber ifNotNil: 
					[display label: (previousNumber perform: currentOperation asSymbol with:  display label asNumber ) asString].
				previousNumber := nil ];
		state: true! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:39'!
height
	"(4@4) is the size of the border"

	^ 187 + (4 @ 4)! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:39'!
initialExtent
	"(4@4) is the size of the border"

	^ 247 @ self height! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/6/2014 15:36'!
initialize
	operationPending  := false.
	super initialize! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/5/2014 14:33'!
initializeDigitButtons
	button0 := self newButton.
	button1 := self newButton.
	button2 := self newButton.
	button3 := self newButton.
	button4 := self newButton.
	button5 := self newButton.
	button6 := self newButton.
	button7 := self newButton.
	button8 := self newButton.
	button9 := self newButton.
	self defineDigitButtons! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:49'!
initializeLayout
	self layout: (SpecLayout composed
		newColumn: [ :column | column
						add: #display ;
						newRow: [ :row1 | row1
										add: #buttonClear;
										add: #buttonLog;
										add: #buttonChange;
										add: #buttonSqr ] height: 26;
						newRow: [ :row2 | row2
										add: #button1;
										add: #button2;
										add: #button3;
										add: #buttonDiv ] height: 26;
						newRow: [ :row3 | row3
										add: #button4;
										add: #button5;
										add: #button6;
										add: #buttonMult ] height: 26;
						newRow: [ :row4 | row4
										add: #button7;
										add: #button8;
										add: #button9;
										add: #buttonMinus ] height: 26;
						newRow: [ :row5 | row5
										add: #buttonDot;
										add: #button0;
										add: #buttonEq;
										add: #buttonPlus ] height: 26 ];
		yourself)! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/5/2014 14:46'!
initializeOtherButtons
	"instantiate the basic arithmetic buttons"

	buttonPlus := self newButton.
	buttonMinus := self newButton.
	buttonMult := self newButton.
	buttonDiv := self newButton.
	buttonEq := self newButton.	
		
	"instantiate the remaining buttons"
	buttonDot := self newButton.
	buttonSqr := self newButton.
	buttonLog := self newButton.
	buttonChange := self newButton.
	buttonClear := self newButton.
	
	self defineOtherButtons! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 19:58'!
initializeWidgets 
	self initializeDigitButtons. 
	self initializeOtherButtons. 
	display := self newLabel.
	self initializeLayout ! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:17'!
logarithm
	buttonLog
		label: 'Log';
		action: [ display label: display label asNumber log asString ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 18:26'!
multiplication
	buttonMult
		label: 'x';
		action: [ self operation: $* ];
		state: true! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 15:31'!
newDisplayLabelFor: aString
	^operationPending ifTrue: [operationPending  := false. aString ]  ifFalse: [ display label , aString ] ! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 16:06'!
newDisplayLabelForDot
	^ (operationPending or: [display label isEmpty])
		ifTrue: [ operationPending := false.  '0.' ]
		ifFalse: [  (display label includes: $.) 
						ifTrue: [ display label ] 
						ifFalse:  [ display label,  '.' ] ]! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 16:16'!
operation: aCharacter
	"Defines which operation will be performed: it can be a + / - x"

	previousNumber := display label asNumber.	
	currentOperation := aCharacter.				
	operationPending  := true.! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/5/2014 17:08'!
sqrCheck
	"checks whether we are attempting to calculate the square root of a negative
number"

	display label asNumber < 0
		ifTrue: [ display label: 'Error' ]
		ifFalse: [ display label: display label asNumber sqrt asString ]! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:07'!
squareRoot
	buttonSqr
		label: 'Sqr';
		action: [ self sqrCheck ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:05'!
subtraction
	buttonMinus
		label: '-';
		action: [ self operation: $- ];
		state: true! !

DynamicComposableModel subclass: #SvoListUI
	instanceVariableNames: 'list listHeight model emptyLabel editBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!SvoListUI commentStamp: 'hk 2/5/2015 13:01' prior: 0!
A SpoListUI is an abstract superclass for a list slot UI

Instance Variables
	list:			<ListModel>
	listHeight:
	model:
	emptyLabel: 
	editBlock:
!

SvoListUI subclass: #SvoDynamicListUI
	instanceVariableNames: 'source button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!SvoDynamicListUI commentStamp: 'hk 12/14/2014 11:41' prior: 0!
I am a UI for a DSL generated list

Instance Variables
	button:		<ButtonModel>			the exec button of the DSL
	source:		<TextInputFieldModel>	the DSL source !

!SvoDynamicListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:32'!
button
	^ button! !

!SvoDynamicListUI methodsFor: 'ui-actions' stamp: 'hk 1/14/2015 13:29'!
exec
	| res |
	model source: source text.
	(res := model exec) isString ifTrue: [ SvoSpecUI alert: res ] .
	list items: model list 
	! !

!SvoDynamicListUI methodsFor: 'as yet unclassified' stamp: 'hk 1/21/2015 16:15'!
height
	^ super height + self singleHeight ! !

!SvoDynamicListUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:33'!
initializeLayout
	"(SpoDynamicListUI on: SpoDynamicList new) openWithSpec"

	self layout: (SpecLayout composed
		newColumn: [ :c |  
			c newRow:  [ :r |  r 
				add: #source ; add: #button width: 80] 
				height: self singleHeight .
			c add: #list  ]  )! !

!SvoDynamicListUI methodsFor: 'initialization' stamp: 'hk 1/19/2015 15:09'!
initializeWidgets
	"(SpoDynamicListUI on: SvoDynamicList new) openWithSpec"
	source := (self newTextInput)
						autoAccept: true;
						ghostText: 'undefined'.
	source text: model source.
	(button := self newButton)
		label: 'exec';
		action: [ self exec ];
		state: true.
	listHeight :=  self singleHeight * 3 .
	super initializeWidgets ! !

!SvoDynamicListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:28'!
save
	model source: source text! !

!SvoDynamicListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:28'!
source
	^ source! !

!SvoListUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 17:48'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!SvoListUI methodsFor: 'private' stamp: 'hk 2/5/2015 19:12'!
displayItem: anItem
	"also adjust list spacings to list head spacings"
	| str |
	str := ''.
	(anItem displayArray do: [ :s | str := str, (s padRightTo: (self paddingFor: s)) ]) .
	^str
	
	! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/5/2015 13:01'!
editBlock: aBlock 
		editBlock := aBlock

! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/5/2015 13:02'!
editSvo
	editBlock 
		ifNil: [ self selectedItem edit ] 
		ifNotNil: [ editBlock value: self selectedItem ]

! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/3/2015 15:34'!
emptyLabel
	^ emptyLabel ! !

!SvoListUI methodsFor: 'ui-helpers' stamp: 'hk 2/3/2015 14:23'!
height
	^listHeight + self singleHeight 
	! !

!SvoListUI methodsFor: 'initialization' stamp: 'hk 2/5/2015 19:41'!
initializeLayout
	"(SvoListUI on: (SvoList new add: ((VO new: #root) addValue: #bla1 at: #bla2 forDisplay: true; yourself); key: #bla) ) openWithSpec "
	"(CommonSlotUI on: (SvoList new add: ((VO new: #root) addValue: #bla1 at: #bla2 forDisplay: true; yourself); key: #bla) type: SvoListUI) openWithSpec"

	self layout: (SpecLayout composed
		newColumn: [ :c | 
			c newRow: [ :r | 
				list listItems first displayLabelArray do: 
					[ :l | r add: l width: 130 ] .
					 r add: #emptyLabel ] height: self singleHeight .
			c  add: #list ] )! !

!SvoListUI methodsFor: 'initialization' stamp: 'hk 2/5/2015 18:21'!
initializeWidgets
	list := self newList  .
	list items: model list.  
	list displayBlock: [ :item | self displayItem: item  ] .
	list 	menu: [ :menu | menu 	target: self;
								add: 'edit'  action: #editSvo ].
	listHeight :=  self singleHeight  * ( (list listSize /2 max: 2) min: 4 ).  
	"need a trick for the column titles"
	list listItems ifNotEmpty: [list listItems first displayLabelArray do: 
		[ :l | self assign: (LabelModel new text: l) to: l asSymbol ] ].
	emptyLabel := LabelModel new .	"fills up the space"
	self needRebuild: true . 
	self initializeLayout! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 11/27/2014 18:53'!
list
	^ list! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:49'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:49'!
model: aSlot
	model := aSlot! !

!SvoListUI methodsFor: 'private' stamp: 'hk 2/5/2015 19:40'!
paddingFor: aString

	^30 - ((aString size /3 ) rounded)
	
	! !

!SvoListUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 21:49'!
save
	
! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/5/2015 12:52'!
selectedItem
	^list  listItems at:  list getIndex ifAbsent: [ ^self error: 'nothing selected' ]  

! !

!SvoListUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 17:54'!
singleHeight
	^self class toolbarHeight 
	! !

SvoListUI subclass: #SvoStaticListUI
	instanceVariableNames: 'accuFields template addAccuButton addNewButton addShowButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!SvoStaticListUI commentStamp: 'hk 2/2/2015 19:14' prior: 0!
I am a UI for a static spo list slot

Instance Variables
	addAccuButton:	<ButtonModel >
	addShowButton:	<ButtonModel >
	addNewButton:		<ButtonModel>
	template:			<TextInputFieldModel >
	accuFields:			<Coll of Array:2>			widget labels
!

!SvoStaticListUI methodsFor: 'ui actions' stamp: 'hk 1/5/2015 19:14'!
addAccu
	| res1 |
	(res1 := VO chooseValueFrom: model templateValueSlotKeys mess: 'which field to accumulate?' ) ifNil: [ ^self ] .
	model addAccumulator: res1 asSymbol.
	model frame reOpen

! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 15:11'!
addAccuButton
	^ addAccuButton! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 15:20'!
addNewButton
	^ addNewButton! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 15:59'!
addShowButton
	^ addShowButton! !

!SvoStaticListUI methodsFor: 'ui actions' stamp: 'hk 1/15/2015 14:12'!
addSvo
	model templateName: template text.
	model addExemplar.
	model frame reOpen
! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:28'!
height
	^self singleHeight * (accuFields size * 0.7 +1) + super height 
	! !

!SvoStaticListUI methodsFor: 'initialization' stamp: 'hk 2/4/2015 17:33'!
initializeLayout
	"(SvoStaticListUI on: SvoStaticList new) openWithSpec"
	"|t| (SvoStaticListUI on: ((t := VO new: #Bla ) addSvoStaticList: t at: #bla ) ) openWithSpec"

	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow:  [ :r |  r add: #template ; 
			add: #addShowButton width: 80;
			add: #addNewButton width: 80; 
			add: #addAccuButton width: 80] height: self singleHeight  .
		c add: #list .
		accuFields do: 
			[ :a | c newRow: [ :r | r add: (a at: 1); add: (a at: 2) ] 
			height: self singleHeight * 0.7] ]  )! !

!SvoStaticListUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 19:24'!
initializeWidgets	
	accuFields := OrderedCollection new.
	model accumulatorsWithSums pairsDo: [ :m :s |   | mv | 
		mv := (m, 'Value' ) asSymbol.
		accuFields add: (Array with: m with: mv) .
		self assign: (LabelModel new label: 'sum of ', m) to: m; assign: (LabelModel new label: s printString) to: mv ].
	template := (self newTextInput)
						autoAccept: true;
						ghostText: 'undefined'.    
	template text: model templateName.
	(addShowButton := self newButton)
		label: 'show' ;
		action: [ self showSvos ];
		state: true .
	(addNewButton := self newButton)
		label: 'new' ;
		action: [ self addSvo ];
		state: true .
	(addAccuButton := self newButton)
		label: 'add accu';
		action: [ self addAccu ];
		state: true.
	super initializeWidgets ! !

!SvoStaticListUI methodsFor: 'ui actions' stamp: 'hk 2/2/2015 21:50'!
save
	model templateName: template text.

! !

!SvoStaticListUI methodsFor: 'ui actions' stamp: 'hk 2/2/2015 19:06'!
showSvos
	model templateName: template text.
	model frame reOpen
! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 1/17/2015 18:33'!
template
	^ template! !

DynamicComposableModel subclass: #SvoSpecUI
	instanceVariableNames: 'fullName version addValue addMethod model height isListEditor fields refresh addValueDsl insp elderName addSvo addSvoDynamicList addSvoInList addSvoStaticList svoAnnouncer addDropList menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!SvoSpecUI commentStamp: 'hk 12/31/2014 17:35' prior: 0!
A SpoSpecUI is the generic UI for SPO

Instance Variables
	addMethod:		<Object>
	addSpo:		<Object>
	addSpoDynamicList:		<Object>
	addSpoInList:		<Object>
	addSpoList:		<Object>
	addSpoStaticList:		<Object>
	addSubSpo:		<Object>
	addValue:		<Object>
	addValueDsl:		<Object>
	addValueList:		<Object>
	editList:		<Object>
	editStraight:		<Object>
	entityElderName:		<Object>
	fields:		<Object>
	fullName:		<Object>
	height:		<Object>
	insp:		<Object>
	isListEditor:		<Object>
	model:		<Object>
	newType:		<Object>
	redo:		<Object>
	refresh:		<Object>
	reset:		<Object>
	save:		<Object>
	spoAnnouncer:		<Object>
	undo:		<Object>
	version:		<Object>

addMethod
	- xxxxx

addSpo
	- xxxxx

addSpoDynamicList
	- xxxxx

addSpoInList
	- xxxxx

addSpoList
	- xxxxx

addSpoStaticList
	- xxxxx

addSubSpo
	- xxxxx

addValue
	- xxxxx

addValueDsl
	- xxxxx

addValueList
	- xxxxx

editList
	- xxxxx

editStraight
	- xxxxx

entityElderName
	- xxxxx

fields
	- xxxxx

fullName
	- xxxxx

height
	- xxxxx

insp
	- xxxxx

isListEditor
	- xxxxx

model
	- xxxxx

newType
	- xxxxx

redo
	- xxxxx

refresh
	- xxxxx

reset
	- xxxxx

save
	- xxxxx

spoAnnouncer
	- xxxxx

undo
	- xxxxx

version
	- xxxxx
!

!SvoSpecUI class methodsFor: 'ui-helpers' stamp: 'hk 12/3/2014 12:58'!
alert: errorString
	"the system wide alert dialog"

	WidgetExamples new exampleBuilder alert: errorString! !

!SvoSpecUI class methodsFor: 'specs' stamp: 'hk 1/27/2015 13:05'!
asListOn: aSPO
	^ self basicNew
		model: aSPO;
		isListEditor: true;
		initialize;
		yourself! !

!SvoSpecUI class methodsFor: 'specs' stamp: 'hk 11/13/2014 18:51'!
on: aSPO
	^ self basicNew
		model: aSPO;
		isListEditor: false;
		initialize;
		yourself! !

!SvoSpecUI class methodsFor: 'ui-helpers' stamp: 'hk 11/19/2014 12:43'!
request: aString
	"self request: 'test'  "
	^UIManager default request: aString initialAnswer: 'undefined'.
! !

!SvoSpecUI class methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 21:17'!
requestString: aString
	"self request: 'test'  "
	| res |
	res := (UIManager default request: aString initialAnswer: 'undefined' ).
	res ifNil: [ ^res ] .
	^res substrings first
! !

!SvoSpecUI class methodsFor: 'specs' stamp: 'hk 11/11/2014 16:22'!
title
	^ 'SPO Generic Editor'! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:48'!
addDropList
	^ addDropList! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/19/2015 17:49'!
addDropListAction
	| res res2 |
	(res := self askForSlotName ) ifNil: [ ^self ] .
	res2 := self class request: 'enter blank separated list items'.
	model exec: (AddListOfStrings named: res list: res2 substrings ) ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/9/2014 15:09'!
addMethod
	^ addMethod! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 12/10/2014 18:20'!
addMethodAction
	| res |
	(res := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddAction named: res source: '' ) ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/15/2015 14:12'!
addSvo
	^ addSvo! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/26/2015 22:28'!
addSvoAction
	| res1  coll  res2 |
	(res1 := self askForSlotName ) ifNil: [ ^self ] .
	coll := VO allSvoNames.
	(res2 := VO chooseValueFrom: coll mess:  'from which SPO?' ) ifNil: [ ^self ] .
	model exec: (AddSvoCopy named: res1 on: (VO at: res2) ) 
	! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:50'!
addSvoDynamicList
	^ addSvoDynamicList ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/19/2015 17:51'!
addSvoDynamicListAction
	| res1 |
	(res1 := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddSpoDynamicList named: res1 ) 
	! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:51'!
addSvoInList
	^ addSvoInList! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:51'!
addSvoStaticList
	^ addSvoStaticList ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/19/2015 17:51'!
addSvoStaticListAction
	| res1   |
	(res1 := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddSpoStaticList named: res1 ) 
! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/21/2015 15:02'!
addToListMenu    
	menu  addGroup: [ :group |
			group addItem: [ :item | item
				 	name: 'edit frame' ;
					description: 'switch to frame editor';
					action: [ self editAction ] ]  ] 
	! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/21/2015 15:02'!
addToNonListMenu    
	menu  addGroup: [ :group |
			group addItem: [ :item | item
				 	name: 'new type' ;
					description: 'create an ASVO';
					action: [ self newTypeAction ] ].
			group addItem: [ :item | item
				 	name: 'edit list' ;
					description: 'switch to list editor';
					action: [ self editListAction ] ]  ]  

	! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/9/2014 15:09'!
addValue
	^ addValue! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 12/10/2014 17:49'!
addValueAction
	| res |
	(res := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddValue named: res) ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 19:14'!
addValueDsl
	^ addValueDsl! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 12/10/2014 17:49'!
addValueDslAction
	| res |
	(res := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddDslValue named: res ) ! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 12/3/2014 12:59'!
alert: errorString
	"the system wide alert dialog"

	self class alert: errorString! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 2/2/2015 13:39'!
askForSlotName
	| res |
	res := self class requestString: 'new slot name ?'  .
	(model slots keys includes: res) 
		ifTrue: [ self alert: 'slot name exists' . ^nil] 
		ifFalse: [ ^res ]
! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 2/2/2015 13:39'!
askForSvoName
	| res |
	(res := self class requestString: 'new ASPO name?' ) ifNil: [ ^self ] .
	(VO svos includesKey: res)
		ifTrue: [ self alert: 'ASPO name already exists' . ^nil] 
		ifFalse: [ ^res ]! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 11/15/2014 18:45'!
basicHeight
	^ self class toolbarHeight   ! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/19/2015 17:51'!
buttonLayout: column
	column
		newRow: [ :r |  r
				add: #addValue;
				add: #addValueDsl;
				add: #addDropList ;
				add: #addSvo;
				add: #addSvoStaticList;
				add: #addSvoDynamicList;
				add: #addMethod ]
		height: self class toolbarHeight! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/26/2015 22:17'!
copyAsvoAction
	model exec: (CopyAsvo on: model)  .
	self reOpen! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 1/8/2015 15:13'!
defineHeader
	fullName label: model qualifiedName .
	version label: 'version: ', model version .
	elderName label:  'elder: ', model elderName.
	insp label: 'inspect ', model pName ;
		action: [ model inspect ];
		state: true.  ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/21/2015 12:41'!
editAction
	isListEditor := false. 
	self reOpen! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/21/2015 12:42'!
editListAction
	isListEditor := true. 
	self reOpen! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 12/31/2014 18:45'!
elderName
	^ elderName! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/9/2014 15:09'!
fullName
	^ fullName! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 12/31/2014 18:43'!
headerLayout: column
	column
		newRow: [ :r |  r
				add: #fullName;
				add: #elderName ]
			height: self class toolbarHeight;
		newRow: [ :r |  r
				add: #version;
				add: #insp ]
			height: self class toolbarHeight
		! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 11/15/2014 18:44'!
height
	^ self class toolbarHeight   ! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 12/14/2014 13:09'!
initialExtent
	^ 750 @ height ! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 1/21/2015 13:07'!
initialize
	super initialize.
	svoAnnouncer on: CloseFrame do: [ :a | self window close ] .
	svoAnnouncer on: SlotsChanged do: [ :a | self reOpen ] .
	svoAnnouncer on: ReOpenFrame do: [ :a | self reOpen ] ! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 22:37'!
initializeActionButtons 
	(addValue := self newButton) label: 'add value' ;
		action: [self addValueAction];
		state: true.
	(addValueDsl := self newButton) label: 'add value(DSL)' ;
		action: [self addValueDslAction];
		state: true.
	(addDropList := self newButton) label: 'add drop list' ;
		action: [self addDropListAction];
		state: true.
	(addSvo := self newButton) label: 'add SVO' ;
		action: [self addSvoAction ];
		state: true.
	(addSvoInList := self newButton) label: 'add ASVO copy' ;
		action: [self copyAsvoAction ];
		state: true.
	(addSvoStaticList := self newButton ) label: 'add SVO list' ;
		action: [self addSvoStaticListAction ];
		state: true.
	(addSvoDynamicList := self newButton) label: 'add SVO list(DSL)' ;
		action: [self addSvoDynamicListAction ];
		state: true.
	(addMethod := self newButton ) label: 'add action' ;
		action: [self addMethodAction ];
		state: true! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 12/31/2014 18:45'!
initializeHeader
	fullName := self newLabel.
	version := self newLabel.
	elderName := self newLabel.
	insp := self newButton .
	self defineHeader
! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/26/2015 22:10'!
initializeLayout
	self initializeMenu .
	height := 6 * self basicHeight.
		isListEditor 
		ifTrue: [self initializeListLayout   ]  
		ifFalse:  [self initializeNonListLayout ].
	self needFullRebuild: false.! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/26/2015 19:46'!
initializeListLayout

	| models  |		"dynamic widgets"
	models := model exemplarsAsCollOfPairs.
	fields := OrderedCollection new.
	models pairsDo: [ :k :v | fields add: k  . self assign: v to: k ].
	self addToListMenu .
	"layout"
	self layout: (SpecLayout composed
		newColumn: [ :column | 
			column 	add: #menu height: self height.
			self headerLayout: column.
			column newRow: [:r | r add: #addSvoInList] height: self basicHeight. 				
			fields do: [ :f |  | h |
						h := (self widgets at: f)  height.
						height := height + h.
						column add: f height: h ] .
			column addSplitter ])! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/25/2015 15:45'!
initializeMenu 	
	menu := MenuModel new 
		addGroup: [ :g |
			g addItem: [ :i |  i
				name: 'SVO';
				icon: Smalltalk ui icons openIcon;
				subMenu: self svoMenu ] .
			g addItem: [  :i | i
				name: 'refresh' ;
				description: 'get data from model' ;
				action: [ self refreshAction ] ] .
			g addItem: [  :i | i
				name: 'reset' ;
				description: 'undo gui changes' ;
				action: [ self resetAction ] ] .
			g addItem: [  :i | i
				description: 'save to file' ;
				icon: Smalltalk ui icons smallSaveIcon;
				action: [ self saveAction ] ]    ] ;
		addGroup: [ :group |
			group addItem: [ :item | item
					description: 'undo';
					icon: Smalltalk ui icons smallUndoIcon;
					action: [ self undoAction ] ].
			group addItem: [ :item | item
					description: 'redo';
					icon: Smalltalk ui icons smallRedoIcon;
					action: [ self redoAction ] ] ]
! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 2/2/2015 18:15'!
initializeNonListLayout

	| models  |		"dynamic widgets"
	models := model slotsAsCollOfPairs.
	fields := OrderedCollection new.
	models pairsDo: [ :k :v | fields add: k . self assign: v to: k ].
	self addToNonListMenu .
	"layout"
	self layout: (SpecLayout composed
		newColumn: [ :column | 
			column 	add: #menu height: self height.
			self headerLayout: column.
			self buttonLayout: column.
			fields do: [ :f |  | h |
				h := (self widgets at: f)  height.
				height := height + h.
				column add: f height: h ] .
			column addSplitter ])! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:06'!
initializeWidgets
	self initializeHeader .
	self initializeActionButtons .
	self initializeLayout ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 13:45'!
insp
	^ insp! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/13/2014 18:51'!
isListEditor
	^ isListEditor! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 14:01'!
isListEditor: aBoolean
	isListEditor := aBoolean! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/21/2015 15:03'!
menu    
	^ menu
	! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/10/2014 12:00'!
model
	^ model! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/5/2015 14:51'!
model: aSPO
 	model := aSPO.
	svoAnnouncer := model announcer! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/19/2015 17:52'!
newTypeAction
	| res |
	(res := self askForSvoName  ) ifNil: [ ^self ] .
	(model clone: res ) edit! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 1/21/2015 13:06'!
reOpen
	self initializeLayout; openWithSpec
! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/18/2014 12:16'!
redoAction
	model redo ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/20/2014 12:09'!
refreshAction
	self reOpen! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/24/2014 20:54'!
resetAction
	model rollBack! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/20/2014 14:40'!
saveAction
	fields do: [ :f | (widgets at: f) save ].
	model save.
	self reOpen.! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/21/2015 14:12'!
svoMenu
	^ MenuModel new addGroup: [ :group |
			group addItem: [ :item | item
					name: 'refresh';
					shortcut: $f command;
					action: [ self refreshAction ] ].
			group addItem: [ :item | item 
					name: 'reset';
					shortcut: $r command;
					action: [ self resetAction ] ].
			group addItem: [ :item | item 
					name: 'save';
					icon: Smalltalk ui icons smallSaveIcon;
					shortcut: $s command;
					action: [ self saveAction ] ] ]! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/18/2014 12:16'!
undoAction
	model undo ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/9/2014 15:09'!
version
	^ version! !

DynamicComposableModel subclass: #SvoUI
	instanceVariableNames: 'editButton model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!SvoUI commentStamp: 'hk 2/2/2015 21:48' prior: 0!
I am used in the VO list editor. I exhibit an edit button for the VO.

Instance Variables
	editButton:		<ButtonModel >
	model:!

SvoUI subclass: #SvoEmbeddedUI
	instanceVariableNames: 'slotKeysAndValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!SvoEmbeddedUI commentStamp: 'hk 1/6/2015 12:50' prior: 0!
I am used in the VO editor to display the values of an embedded VO

Instance Variables
	slotKeysAndValues:		<Coll of Pairs>

!

!SvoEmbeddedUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 18:48'!
height 
	^(slotKeysAndValues size * 0.9 max: 1) * self singleHeight ! !

!SvoEmbeddedUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:12'!
initializeLayout
	"(SvoEmbeddedUI on: (SvoSlot new svo: ((VO new: #root) addValue: #bla1 at: #bla2 forDisplay: true; yourself) ; key: #bla)) openWithSpec"
	"(CommonSlotUI on: (SvoSlot new svo: ((VO new: #root) addValue: #bla1 at: #bla2 forDisplay: true; yourself); key: #bla) type: SvoEmbeddedUI) openWithSpec"

	self layout: (SpecLayout composed
		newRow: [ :row | row	
			add: #k0 ;
			newColumn: [ :c | slotKeysAndValues do: 
				[ :kv |  c newRow:  [ :r | 
					r add: (kv at: 1) ; 
					  add: (kv at: 2)  ] height: self singleHeight * 0.8] ]  ;
			add: #editButton width: self class buttonWidth ] )
! !

!SvoEmbeddedUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 17:39'!
initializeWidgets
	"(SvoEmbeddedUI on: (SvoSlot new spo: (VO new: #root) ; key: #bla)) openWithSpec"
	
	| k |
	k := 1 .
	slotKeysAndValues := OrderedCollection new.
	self assign: (LabelModel new label: model pName ) to: #k0.
	model svoDisplayValues do: [ :e |  | k1 k2  v1 v2 |
					v1 := e key asSymbol.
					v2 := e displayString asSymbol.
					k1 := ('Key', (k := k +1) asString) asSymbol.
					k2 := ('Key', (k := k +1) asString) asSymbol.
					slotKeysAndValues add: (Array with: k1 with: k2) .
					self assign: (LabelModel new label: v1) to: k1.
					self assign: (LabelModel new label: v2) to: k2].
	(editButton := self newButton) 
		label: 'edit' ;
		action:  [self editAction] ;
		state: true .
	self initializeLayout 



! !

!SvoEmbeddedUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 18:58'!
singleHeight 
 	^self class toolbarHeight ! !

!SvoUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 17:32'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!SvoUI methodsFor: 'ui-actions' stamp: 'hk 1/21/2015 15:33'!
editAction
	model svo edit! !

!SvoUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 20:39'!
editButton
	^editButton 
	
! !

!SvoUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:12'!
initializeLayout
	"(SvoUI on: (SvoSlot new svo: (VO new: #root); key: #bla) ) openWithSpec"
	"(CommonSlotUI on: (SvoSlot new svo: (VO new: #root); key: #bla) type: SvoUI) openWithSpec"

	self layout: (SpecLayout composed
		newRow: [ :row | row  add: #editButton ] )! !

!SvoUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 17:43'!
initializeWidgets
	editButton := self newButton .
	editButton 
		label: model  displayString ;
		action:  [self editAction] ;
		state: true .
	self initializeLayout! !

!SvoUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:37'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!SvoUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:37'!
model: aSlot
	model := aSlot! !

!SvoUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 21:44'!
save! !

DynamicComposableModel subclass: #ValueUI
	instanceVariableNames: 'slotValue model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!ValueUI commentStamp: 'hk 2/2/2015 17:23' prior: 0!
I am the UI component for a slot value , i.e. string

Instance Variables
	slotValue:		<TextInputFieldModel >
	model: 			<ValueSlot>!

!ValueUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 15:36'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!ValueUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:12'!
initializeLayout
	"(CommonSlotUI on: ValueSlot new type: ValueUI) openWithSpec"
	"(ValueUI on: ValueSlot new) openWithSpec"

	self layout: (SpecLayout composed
		newRow: [ :row | row add: #slotValue ] )! !

!ValueUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 17:30'!
initializeWidgets
	(slotValue := self newTextInput
						autoAccept: true;
						ghostText: 'undefined')
				  text: model value.
	self initializeLayout ! !

!ValueUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 15:30'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!ValueUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 15:37'!
model: aSlot
	model := aSlot! !

!ValueUI methodsFor: 'ui-actions' stamp: 'hk 2/2/2015 15:37'!
save
	model value: slotValue text! !

!ValueUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 19:48'!
slotValue
	^ slotValue! !

Announcement subclass: #CloseFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Announcements'!

!CloseFrame commentStamp: 'hk 12/3/2014 15:59' prior: 0!
A CloseFrame is an Announcement to close the UI 
!

Announcement subclass: #ReOpenFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Announcements'!

!ReOpenFrame commentStamp: 'hk 11/18/2014 15:04' prior: 0!
A ReOpenFrame is an Announcement to reOpen the UI !

Announcement subclass: #SlotsChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Announcements'!

!SlotsChanged commentStamp: 'hk 11/18/2014 12:02' prior: 0!
A SposChanged is an Announcement for thr UI to refresh
!

Announcer subclass: #SvoAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Announcements'!

!SvoAnnouncer commentStamp: 'hk 11/19/2014 13:14' prior: 0!
A SpoAnnouncer is the Announcer for SPO
!

!SvoAnnouncer methodsFor: 'printing' stamp: 'hk 11/19/2014 17:33'!
storeOn: aStream 	
	aStream nextPutAll: 'nil'! !

TestCase subclass: #SvoTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

SvoTests class
	instanceVariableNames: 'firma vorgang angebot auftrag kalkulation transport tour rechnung kunde adresse position 
	 gcMainContext address personIdentity person date gcBizProcessContext process gcProcessesContext'!

!SvoTests commentStamp: 'hk 12/3/2014 15:24' prior: 0!
The SpoTests class

for manual experience evaluate <SpoTests new openSample >.

You can play around manually. DSL comes into play with 
- DSL add value
- DSL add SPO
- add action 

Try the following DSL fragments in the (undefined) source fields:
- strasse @ Adresse (Frankfurt)
- Kontakt (Krasemann)
- email an Kontakt(Fritz)
!

SvoTests class
	instanceVariableNames: 'firma vorgang angebot auftrag kalkulation transport tour rechnung kunde adresse position 
	 gcMainContext address personIdentity person date gcBizProcessContext process gcProcessesContext'!

SvoTests subclass: #SvoTestSuiteCommands
	instanceVariableNames: 'adr kontakt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteCommands commentStamp: 'hk 12/1/2014 17:41' prior: 0!
A SpoTestSuiteCommands is xxxxxxxxx.

Instance Variables
	adr:		<SPO>
	kontakt:	<SPO>



!

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/4/2014 16:48'!
setUp
	super setUp.
	adr := self class makeAdresse.
	kontakt := self class makeKontakte 
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:51'!
testAddMethod
	kontakt exec: ( AddAction named: 'bla' source: '' ).	
	self should: [ kontakt dslSlots size = 1 ].
	self should: [ kontakt slots size = 4 ].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 1/26/2015 22:28'!
testAddSvo
	|  child cmd |
	kontakt exec: (cmd := AddSvoCopy named: adr pName on: adr ).	
	child := (kontakt svoSlots detect: [ :a | (adr pName, '*' ) match:  a value svo pName ]) svo.
	
	self should: [ (adr pName, '_1' ) = child pName ].
	self should: [ adr copiesColl includes: child  ].
	self should: [ (VO at: child pName) elder = kontakt ].
	self should: [ ((VO at: child pName) elderVersion ) = kontakt version].
	self should: [ kontakt slots size = 4 ].
	self should: [ (VO at: child pName) template = adr ].
	self should: [ ((VO at: child pName) templateVersion ) = adr version].
	^child
! !

!SvoTestSuiteCommands methodsFor: 'helpers' stamp: 'hk 1/21/2015 15:38'!
testAddSvoList
	kontakt exec: ( AddSpoDynamicList named: #freunde source: '').	
	self should: [kontakt svoDynamicListSlots size = 1] .
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:52'!
testAddValue
	kontakt exec: ( AddValue named: 'bla' value: '' ).	
	self should: [ kontakt valueSlots size = 4 ].
	self should: [ kontakt slots size = 4 ].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 1/26/2015 22:17'!
testCreateSvo
	|  child cmd |
	kontakt exec: (cmd := CopyAsvo on: adr).	
	child := (adr copiesColl detect: [ :a | (adr pName, '*' ) match:  a pName ]) value.
	
	self should: [ (adr pName, '_1' ) = child pName ].
	self should: [ child template  = adr ].
	self should: [ child templateVersion  = adr version].
	self should: [ adr copies size = 1 ]
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:49'!
testMoveUpDown
	self should: [ (kontakt slotSequence at: 2) = #vorname  ].
	kontakt exec: ( MoveUp named: #vorname ).	"first MoveUp"
	self should: [ (kontakt slotSequence at: 1) = #vorname  ].
	kontakt exec: ( MoveUp named: #vorname).	"second MoveUp"
	self should: [ (kontakt slotSequence at: 1) = #vorname  ].
	kontakt exec: ( MoveDown named: #vorname ).	
	kontakt exec: ( MoveDown named: #vorname ).	"2 * MoveDown"
	self should: [ (kontakt slotSequence at: 3) = #vorname  ].
	kontakt exec: ( MoveDown named: #vorname ).	" MoveDown"
	self should: [ (kontakt slotSequence at: 3) = #vorname  ].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:50'!
testMoveUpUndo
	self should: [ (kontakt slotSequence at: 2) = #vorname  ].
	kontakt exec: ( MoveUp named: #vorname ).	"first MoveUp"
	self should: [ (kontakt slotSequence at: 1) = #vorname  ].
	kontakt undo.
	self should: [ (kontakt slotSequence at: 2) = #vorname  ].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 1/21/2015 15:38'!
testRedo
	|  child  |
	child := self testAddSvo.
	kontakt undo.
	kontakt redo.
	self should: [ kontakt slots size = 4 ].	
	self should: [ (adr pName, '_1' ) = child pName ].
	self should: [ adr copiesColl includes: child  ].
	self should: [ (VO at: child pName) elderName  = kontakt pName].
	self should: [ (VO at: child pName) elderVersion   = kontakt version].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:50'!
testRemoveSlot
	kontakt exec: ( RemoveSlot named: 'vorname' ).	
	self should: [ kontakt valueSlots size = 2 ].
	kontakt undo.
	self should: [ kontakt valueSlots size = 3 ].
	self should: [ (kontakt slots at: #vorname) value = 'Hartmut' ].

! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 1/26/2015 22:28'!
testUndo
	kontakt exec: (AddSvoCopy named: adr pName on: adr ).	
	self should: [ kontakt slots size = 4 ].
	kontakt undo.
	self should: [ kontakt slots size = 3 ].
	kontakt undo.							"undo stack isEmpty"
	self should: [ kontakt slots size = 3 ].
! !

SvoTests subclass: #SvoTestSuiteCompiler
	instanceVariableNames: 'adr kontakt email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteCompiler commentStamp: 'hk 12/1/2014 17:40' prior: 0!
A SpoTestSuiteCompiler is 

Instance Variables
	adr:		<SPO>
	kontakt:	<SPO>
	email:		<SPO>


!

!SvoTestSuiteCompiler methodsFor: 'running' stamp: 'hk 12/4/2014 16:49'!
setUp
	super setUp.
	adr := self class makeAdresse.
	kontakt := self class makeKontakte .
	email := self class makeEmail
! !

!SvoTestSuiteCompiler methodsFor: 'running' stamp: 'hk 1/7/2015 14:00'!
testDslMethod
	kontakt exec: ( AddAction named: 'bla' source: 'email an Kontakt(Fritz)' ).	
	(kontakt slots at: #bla) exec .
	(VO at: #Email_1) closeWindow.
	self should: [ VO svos includesKey:  #Email_1 ]
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 1/26/2015 22:28'!
testDslPathSearch1

	| adr1 |
	kontakt exec: (AddSvoCopy named: adr pName on: adr ).	
	self should: [(adr1 := VO at: #Adresse_1) valueSlots size  = 3 ].
	adr1 exec: ( AddDslValue named: #item source: 'vorname @ parent' ).	
	(adr1 valueSlots at: #item) exec.
	self should: [adr1 valueSlots size  = 4].
	self should: [(adr1 valueSlots at: #item ifAbsent: [ '' ]) value = 'Hartmut' ].
	
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 1/26/2015 22:28'!
testDslPathSearch2

	| adr1 |
	kontakt exec: (AddSvoCopy named: #adr on: adr ).	
	self should: [(adr1 := VO at: #Adresse_1) valueSlots size  = 3 ].
	adr1 exec: ( AddDslValue named: #item source: 'strasse @ adr @ parent' ).	
	(adr1 valueSlots at: #item) exec.
	self should: [adr1 valueSlots size  = 4].
	self should: [(adr1 valueSlots at: #item ifAbsent: [ '' ]) value = 'Rheinstr. 7' ].
	
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 1/26/2015 22:28'!
testDslPathSearch3

	| adr1 |
	kontakt exec: (AddSvoCopy named: #adr on: adr ).	
	self should: [(adr1 := VO at: #Adresse_1) valueSlots size  = 3 ].
	kontakt exec: ( AddDslValue named: #item source: 'strasse @ adr' ).	
	(kontakt valueSlots at: #item) exec.
	self should: [kontakt valueSlots size  = 4].
	self should: [(kontakt valueSlots at: #item ifAbsent: [ '' ]) value = 'Rheinstr. 7' ].
	
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 1/26/2015 22:28'!
testDslPathSearch4
	"like testDslPathSearch2 on a copy"
	| adr1 adr2 k2 |
	kontakt exec: (AddSvoCopy named: #adr on: adr ).	
	self should: [(adr1 := VO at: #Adresse_1) valueSlots size  = 3 ].
	adr1 exec: ( AddDslValue named: #item source: 'strasse @ adr @ parent' ).	
	k2 := kontakt copy.
	adr2 := (k2 slots at: #adr) svo.
	(adr2 valueSlots at: #item) exec.
	self should: [(adr2 valueSlots at: #item ifAbsent: [ '' ]) value = 'Rheinstr. 7' ].
	
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 1/5/2015 19:14'!
testDslSlotSearch
	self should: [kontakt valueSlots size = 3 ].
	(VO at: #Adresse) copy.   "the DSL only searches exemplars"
	kontakt exec: ( AddDslValue named: #item source: 'strasse @ Adresse (Frankfurt)' ).	
	(kontakt valueSlots at: #item) exec.
	self should: [kontakt valueSlots size = 4 ].
	self should: [(kontakt valueSlots at: #item) value = 'Rheinstr. 7' ].
	
	(kontakt valueSlots at: #item) source: 'strasse @ Adresse (F)'.
	(kontakt valueSlots at: #item) exec.
	self should: [(kontakt valueSlots at: #item) value = 'error: #(''F'') not found' ].
	
	(kontakt valueSlots at: #item) source: 'strasse @ A (F)'.
	(kontakt valueSlots at: #item) exec.
	self should: [(kontakt valueSlots at: #item) value = 'error: A not found' ].
	
	(kontakt valueSlots at: #item) source: 'strass @ Adresse (Frankfurt)'.
	(kontakt valueSlots at: #item) exec.
	self should: [(kontakt valueSlots at: #item) value = 'error: strass' ].

! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 1/5/2015 19:14'!
testDslSlotSearch2
	self should: [kontakt valueSlots size = 3 ].
	(VO at: #Adresse) copy.   "the DSL only searches exemplars"
	kontakt exec: ( AddDslValue named: #item source: 'strasse @ Adresse (Frankfurt D22869)' ).	
	(kontakt valueSlots at: #item) exec.
	self should: [kontakt valueSlots size = 4 ].
	self should: [(kontakt valueSlots at: #item) value = 'Rheinstr. 7' ].
	
	! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 1/21/2015 15:38'!
testDslSvoList
	kontakt exec: ( AddSpoDynamicList named: #freunde source: 'Kontakt (Krasemann)' ).	
	(kontakt svoDynamicListSlots at: #freunde) exec.
	self should: [(kontakt svoDynamicListSlots at: #freunde) list size = 4 ].
	(kontakt svoDynamicListSlots at: #freunde) source: 'Kontakt ( Karl)'.
	(kontakt svoDynamicListSlots at: #freunde) exec.
	self should: [(kontakt svoDynamicListSlots at: #freunde) list size = 1 ].
	(kontakt svoDynamicListSlots at: #freunde) source: 'Kontakt ( XX )'.
	(kontakt svoDynamicListSlots at: #freunde) exec.
	self should: [(kontakt svoDynamicListSlots at: #freunde) list isEmpty ].

! !

SvoTests subclass: #SvoTestSuiteCopyClone
	instanceVariableNames: 'adr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteCopyClone commentStamp: 'hk 11/19/2014 16:47' prior: 0!
A SpoTestSuiteCopyClone is xxxxxxxxx.

Instance Variables
	adr:		<SPO>

!

!SvoTestSuiteCopyClone methodsFor: 'helpers' stamp: 'hk 12/4/2014 16:49'!
setUp
	super setUp.
	adr := self class makeAdresse
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 1/21/2015 15:36'!
testAsvoCloning
	"chain  testRoot - testValues - testASPOcloning"
	| adr2 |
	adr2 := adr clone: 'MyAdresse' .

	self should: [ #MyAdresse =  adr2 pName ].	
	self should: [  adr2 version  = '1' ].	
	self should: [ (adr slots at:  'city' ) value = (adr2 slots at:  'city' ) value].
	self should: [ (adr slots at:  #strasse) value = (adr2 slots at:  #strasse) value ].
	self should: [ (adr slots at:  #PLZ) value = (adr2 slots at:  #PLZ) value ].

! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 1/21/2015 15:37'!
testAsvoCloningWrongName
	self should: [ adr clone: 'Adresse' ] raise: Error
! !

!SvoTestSuiteCopyClone methodsFor: 'helpers' stamp: 'hk 1/8/2015 15:07'!
testStoreVersion
	|  oldV |
	oldV := adr version.
	adr save  .
	self should: [ oldV asInteger + 1 = adr version asInteger]
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 1/21/2015 15:37'!
testSvoCopy1
	|   kontakt k2 k4  |
	kontakt := self class makeKontakte .
	k2 := VO at: 'Kontakt_2'.
	k4 := VO at: 'Kontakt_4'.

	self should: [kontakt copies size = 4 ].
	self should: [( kontakt slots at: 'vorname') value = 'Hartmut' ].
	self should: [( k2 slots at: 'vorname') value = 'Karl' ].
	self should: [( k4 slots at: 'vorname') value = 'Fritz' ].
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 1/21/2015 15:37'!
testSvoCopy2
	|   kontakt    k2 adr2 |
	kontakt := self class makeKontakt .
	adr2 := (kontakt addSvo: adr at: #adr) svo .
	self should: [kontakt slots size = 4].
	self should: [( kontakt slots at: #adr) pName = adr pName].
	self should: [( kontakt slots at: #adr) frame pName = kontakt pName].	
	k2 := kontakt copy.
	self should: [( k2 slots at: #adr) pName = (adr pName, '_1')].
	self should: [( k2 slots at: #adr) frame pName = (kontakt pName, '_1')].	
! !

!SvoTestSuiteCopyClone methodsFor: 'helpers' stamp: 'hk 1/21/2015 15:47'!
xtestDelete
	| fn  new |
	adr delete  .
	fn := adr fileName.
	new := SvoStorage readDsvo:  fn. 
	self should: [ new deleted  ].
	self should: [ adr deleted ].
	self should: [ new version = adr version ].
	self should: [ new pName = adr pName ]! !

!SvoTestSuiteCopyClone methodsFor: 'helpers' stamp: 'hk 1/21/2015 15:47'!
xtestStore
	| fn vers new |
	vers := adr version . 
	adr save.
	fn := adr fileName.
	new := SvoStorage readDsvo:  fn. 
	self should: [ new deleted not ].
	self should: [ adr deleted not ].
	self should: [ new version = (vers + 1) ].
	self should: [ new pName = adr pName ].
	self should: [ new slots size = adr slots size ].
	
	
	
"	hier fehlennoch viele weitere Checks
"! !

SvoTests subclass: #SvoTestSuiteServices
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteServices methodsFor: 'as yet unclassified' stamp: 'hk 12/4/2014 16:49'!
setUp
	super setUp.
	self class makeAdresse.
	self class makeKontakte
! !

!SvoTestSuiteServices methodsFor: 'running' stamp: 'hk 1/21/2015 15:38'!
testAllSvoNames
	| res |
	res := VO allSvoNames .
	self should: [ res size = 6 ].
	self should: [ res first isString ].
! !

!SvoTestSuiteServices methodsFor: 'running' stamp: 'hk 1/7/2015 14:01'!
testSearch
	"test spoNameFrom:wirh: is missing - requires UI interaction"
	| res |
	res := VO svoNamesFrom: #Kontakt with: #(#Fritz).
	self should: [ res size = 1 ].
	self should: [ res first isString ].
	res := VO svoNamesFrom: #Kontakt with: #(#Krasemann  #Hartmut).
	self should: [ res first isString ].
	self should: [ res size = 2 ] ! !

!SvoTestSuiteServices methodsFor: 'running' stamp: 'hk 1/7/2015 14:01'!
testSelection
	"test with aColl of size > 1 missing - requires UI interaction"
	| res |
	res := VO svoNamesFrom: #Kontakt with: #Fritz.
	res := VO selectFrom: res .
	self should: [ res isString ] ! !

!SvoTestSuiteServices methodsFor: 'running' stamp: 'hk 1/5/2015 19:14'!
testValueLookup
	"test with missing key is missing - requires UI interaction"
	| res |
	res := VO valueNamed: #email of:  #Kontakt_4.
	self should: [ res value = 'Fritz@Krasemann.de' ] ! !

SvoTests subclass: #SvoTestSuiteSlotBasics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 1/5/2015 19:14'!
testAddSlotWrongName
	| spo |
	spo := VO new: 'root' .
	spo addValue: 'something' at: #bla .
	self should: [spo addValue: 'more' at: #bla ] raise: Error 
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 1/14/2015 11:17'!
testAddSlots
	| spo |
	spo := VO new: 'root' .
	spo addMethod:   'something' at: #bla .
	spo addSvo: self class makeAdresse at: #bla2.
	spo addValue: 'something else' at: #bla3 .
	spo addValueList: #( #a #b#c) at: #bla4 .
	spo addSvoDynamicList: 'Adresse (Frankfurt)' at: #freunde.
	self should: [ spo slots size = 5 ].  
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 12/10/2014 14:10'!
testAddValues
	| spo |
	spo := self class makeAdresse.
	self should: [ 'Frankfurt' = (spo slots at: #city) value ].
	self should: [ 'Rheinstr. 7' = (spo slots at: #strasse) value ].
	self should: [ 'D22869' = (spo slots at: #PLZ) value ].
	^spo! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 12/4/2014 18:09'!
testDisplayValues
	| spo |
	spo := self class makeAdresse.
	spo removeSlot: #city.
	spo addValue: 'Bonn' at: #city forDisplay: true.
	self should: [ 'Bonn' = (spo slots at: #city) value ].
	self should: [ '*Bonn*' match: spo displayString  ].
	self should: [ ('*286*' match: spo displayString ) not ].
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 1/14/2015 11:16'!
testEntityElder
	| spo |
	spo := VO new: 'root' .
	spo addSvo: self class makeAdresse at: #bla.
	self should: [ (VO at: #Adresse) elder notNil ].  
	self should: [ (VO at: #Adresse) elder pName = spo pName ].  
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 11/19/2014 14:04'!
testRemoveValues
	| spo |
	spo := self testAddValues.
	spo  removeSlot: 'city' .
	spo removeSlot: 'strasse' .
	spo removeSlot: 'PLZ' .
	self should: [ spo slots isEmpty  ].
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 1/5/2015 19:14'!
testRetrieve
	VO new: 'root' .
	self should: [ #root =  (VO at: 'root') pName ].  "explicit retrieve"
! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 1/26/2015 17:29'!
authorGloConn
	"self authorGloConn"
	
	self createUC1 .	
	self populateUC1 .

	(SvoSpecUI on: gcProcessesContext ) openWithSpec 	.
	(SvoSpecUI on: gcBizProcessContext ) openWithSpec 	.
	^(SvoSpecUI on: gcMainContext ) openWithSpec ! !

!SvoTests class methodsFor: 'scripts' stamp: 'hk 1/14/2015 11:17'!
createCompany
	"self createCompany"
	
	self createCompanyStaticSPO ; 
		createCompanyDslSlots .
	
	firma addSvoDynamicList: 'GloConnVorgang (V4711)' at: #vorgaenge .
	vorgang addSvo: angebot at: #angebot.
	vorgang addSvo: auftrag at: #auftrag.
	vorgang addSvo: kalkulation at: #kalkulation.
	vorgang addSvo: transport at: #transport.
	vorgang addSvo: rechnung at: #bill.
	vorgang addSvo: kunde at: #kunde .

	auftrag addSvoStaticList: position at: #positionen . 

	kunde addSvo: adresse at: #adresse .

	position addSvo: tour at: #tour .
		
	firma edit.
	vorgang copy.
	vorgang copy.
	vorgang edit.
! !

!SvoTests class methodsFor: 'scripts' stamp: 'hk 1/14/2015 11:17'!
createCompanyDslSlots
	"self createCompany"
	
	vorgang addMethod: 'aktualisiereRechnung' at: #updateBill . 

	auftrag addValueDsl: 'preis@position' at: #wert .

	transport addSvoDynamicList: 'GloConnTour (V4711)' at: #touren .
	transport addMethod: 'neueTour an GloConnVorgang (V4711)' at: #neueTour .

	kalkulation addValueDsl: 'kosten @ GloConnTransport ( V4711 )' at: #kosten .
	kalkulation addMethod: 'neueTour an GloConnVorgang (V4711)' at: #neueTour .
	
	position addValueDsl: 'kosten@tour' at: #preis .
	
	rechnung addValueDsl: 'Name@kunde@parent' at: 'kundenName' .
	rechnung addValueDsl: 'wert@auftrag@parent' at: 'preis' .
	rechnung addValueDsl: 'preis@position@auftrag@parent' at: 'positionsPreis' .
! !

!SvoTests class methodsFor: 'scripts' stamp: 'hk 1/5/2015 19:14'!
createCompanyStaticSPO
	"self createCompany"

	firma := (VO new: 'GloConnGmbH' )
		 addValue: 'Dr. Christoph Crasemann' at:  'Inhaber' ;
		 addValue: 'Dr. Christoph Crasemann' at:  'Buchhalter' ;
		 addValue:  'Dr. Hartmut Krasemann' at: 'Disponent' ;
		 addValue: 'Euros' at:  'Gewinn' ;
		yourself.
	vorgang := (VO new: 'GloConnVorgang' )
		 addValue:  'V0000 ' at: 'id' ;
		 addValue: 'Datum/leer' at:  'start' ;
		 addValue:  'ja/nein' at: 'abgerechnet' ;
		 addValue: 'Datum/leer' at: 'archiviert' ;
		yourself.
	angebot := (VO new: 'GloConnAngebot' )
		 addValue: 'Euros' at: 'Preis' ;
		 addValue:  'Beschreibung' at: #Leistung ;
		yourself.
	auftrag := (VO new: 'GloConnAuftrag' )
		 addValue: 'Datum/leer'  at: #Termin;
		yourself.
	kalkulation := (VO new: 'GloConnKalkulation' )
		 addValue: 'km'  at: #entfernung ;
		yourself.
	transport := (VO new: 'GloConnTransport' )
		 addValue:  'ja/nein'  at: #fertig;
		 addValue:  'Euro'  at: #kosten;   "Akkumulator über Touren"
		yourself.
	tour := (VO new: 'GloConnTour' )
		 addValue:  'key' at:  #vorgang;
		 addValue: '100'  at: #km;
		 addValue:  '100'  at: #kg;
		 addValue:  '1'  at: #cbm ;
		 addValue: 'ja/nein'  at: #ausgeliefert;
		 addValue:  'Euro'  at: #kosten;
		yourself.
	rechnung := (VO new: 'GloConnBill' )
		 addValue:  'Euros'  at: #Endpreis;
		 addValue:  'Tage'  at: #Zahlungsziel;
		yourself.
	adresse := (VO new: 'GloConnAdresse' )
		 addValue:   'Straße'  at: #Strasse;
		 addValue:   'plz'  at: #PLZ;
		 addValue:  'city'  at: #Stadt ;
		yourself.
	kunde := (VO new: 'GloConnKunde' )
		 addValue:   'Müller'  at: #Name;
		 addValue:  'Fritz'  at: #Vorname;
		"#adresse"
		yourself.
	position := (VO new: 'GloConnAuftragsPos' )
		 addValue:   'Text'  at: #Beschreibung;
		yourself.

! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 2/5/2015 19:37'!
createUC1
	"self createUC1"
	
	| gcMainPrintRole gcMainSettings gcNewCustomerFile   gcCopyRole ct sd |
	
	gcCopyRole := (RO new: 'GCCopy' )
		addMethod: 'copy an GCProcess' at: #new;
		yourself.

	gcMainPrintRole := (RO new: 'GCMainPrinting' )
		addMethod: '' at: #print;
		yourself.

	gcMainSettings := (RO new: 'GCMainSetting' )
		addMethod: '' at: #settings;
		yourself.

	gcNewCustomerFile := (RO new: 'GCNewCustomerFile' )
		addMethod: '' at: #newRequest;
		addMethod: '' at: #newOffer;
		addMethod: '' at: #newOrder;
		addMethod: '' at: #newTour;
		yourself.

	gcMainContext := (CF new: 'GCMainContext' )
		 addValue: ' ' at:  'loginTimeStamp' ;
		 addValue: ' ' at:  'loginName' ;
		 addRo:  gcMainPrintRole  ;
		 addRo: gcMainSettings  ;
		 addRo: gcNewCustomerFile  ;
		 addRo: (RO new: 'GCSmartActions' )  ;
		yourself.

	ct := self makeContact .
	sd := self makeServiceDescription.

	process := (VO new: 'GCProcess' )
		addValue: 'undef' at:  #bizFileNo forDisplay: true ;
		addValue: 'undef' at:  #type forDisplay: true;
		addSvo: ct  at: #customer ;
		addValue: 'undef' at:  #status forDisplay: true ;			"BPStatus ?"
		addSvo: sd at: #serviceDescription ;
		addValue: 'undef' at:  #ownership forDisplay: true ;
		addValue: 'undef' at:  #dateDue forDisplay: true ;
		yourself.
		
	gcProcessesContext := (CFlist new: 'GCProcessesContext' )
		addRo: gcCopyRole ;
		asvo: process ;
		yourself .
		
	gcBizProcessContext :=	(CFplain new: 'GCBizProcessContext' )
		addRo: gcCopyRole ;
		addSvo: ct  at: #customer ;
		addSvo: sd at: #serviceDescription ;
		yourself ! !

!SvoTests class methodsFor: 'helpers' stamp: 'hk 1/5/2015 19:14'!
makeAdresse
	^(VO new: 'Adresse' )
		 addValue:  'Rheinstr. 7' at: 'strasse'  ;
		 addValue:  'D22869' at: 'PLZ' ;
		 addValue: 'Frankfurt' at: 'city' forDisplay: true ;
		yourself
! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 1/20/2015 19:02'!
makeContact
	"(SvoSpecUI on: self makeContact) openWithSpec "	
		
	| email tel url communication contactIdentity |
	address := (VO new: 'GCAddress' )
		 addValue:   'street'  at: #street;
		 addValue:   'zip'  at: #zip;
		 addValue:  'city'  at: #city ;
		yourself.
	personIdentity := (VO new: 'GCPersonIdentity' )
		 addValue:   'id'  at: #contactId;
		 addValue:   'name'  at: #lastName;
		 addValue:  'first names' at: #firstName;
		yourself.
	email := (VO new: 'GCemail' )
		 addValueList:  #( #private #biz )  at: #usage;
		 addValue:   ' '  at: #emailAddress;
		yourself.
	tel := (VO new: 'GCtel' )
		 addValueList:   #( #telPrivate #telBiz #faxPrivate #faxBiz #mobile)  at: #usage;
		 addValue:   ' '  at: #telNo;
		yourself.
	url := (VO new: 'GCurl' )
		 addValueList:  #( #private #biz )  at: #usage;
		 addValue:   ' '  at: #url;
		yourself.
	date := (VO new: 'GCdate' )
		 addValue:   ' '  at: #year;
		 addValue:   ' '  at: #month;
		 addValue:   ' '  at: #day;
		addMethod: ' ' at: #checkDate;		"eigentlich ein Constraint"
		yourself.
	communication := (VO new: 'GCCommunication' )
		 addSvoStaticList:   email  at: #email;
		 addSvoStaticList:   tel at: #tel;
		 addSvoStaticList:   url at: #url;
		yourself.		
	person := (VO new: 'GCPerson' )
		 addSvo:  personIdentity at: #personIdentity;
		 addValueList: #( 'Mr.' 'Mrs.' 'Ms.' )  at: #salutation;
		 addValueList: #( '' 'Prof.' 'Dr.' )  at: #xtitle;
		 addSvo:  communication at: #communication;
		 addSvo:  address  at: #address;
		 addValue:   ' '  at: #role;
		 addSvo:  date at: #birthday;
		yourself.
	contactIdentity 	:= (VO new: 'GCContactIdentity' )
		 addValue:   ' '  at: #companyName;
		 addSvo:  person at: #mainContactPerson;
		 addValueList: #( 'supplier' 'customer' 'endCustomer' 'bizContact' )  at: #bizContactRoles;
		yourself.
	^ (VO new: 'GCContact' )
		 addSvo:  contactIdentity  at: #contactIdentity;
		 addSvoStaticList:  person at: #contactStaff;
		yourself.! !

!SvoTests class methodsFor: 'helpers' stamp: 'hk 1/5/2015 19:14'!
makeEmail
	| em  |
	em := VO new: 'Email'.
	em addValue: '' at: 'an' .
 	em addValue:  ''  at: 'betreff' .
	em addValue: '' at: 'text' .
	^ em 
! !

!SvoTests class methodsFor: 'helpers' stamp: 'hk 2/1/2015 20:24'!
makeKontakt
	| kont  |
	kont := VO new: 'Kontakt'.
	kont addValue: 'Krasemann' at: 'nachname' forDisplay: true.
 	kont addValue: 'Hartmut' at:  'vorname' forDisplay: true.
	kont addValue: 'Hartmut@Krasemann' at:  'email' forDisplay: true.
	^ kont
! !

!SvoTests class methodsFor: 'helpers' stamp: 'hk 1/27/2015 14:37'!
makeKontakte
	| aspo  k2  k4 |
	aspo := self makeKontakt .
	aspo copy.
	k2 := aspo copy.
	aspo copy.
	k4 := aspo copy.
	k4 changeValueOf: 'vorname' to:  'Fritz'.
	k2 changeValueOf: 'vorname' to:  'Karl'.
	k4 changeValueOf: 'email' to:  'Fritz@Krasemann.de'; save.
	k2 changeValueOf: 'email' to:  'Karl@Krasemann.de'; save.
	^aspo

! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 1/15/2015 13:52'!
makeServiceDescription
	"(SvoSpecUI on: self makeServiceDescription) openWithSpec "	
		
	| route |	
	route := (VO new: 'GCRoute' )
		addSvo: address at: #origin;
		addSvo: address at: #destination;
		yourself.
		
	position := (VO new: 'GCTransportPosition' )
		addValue: 'LKW ' at: #means;
		addValue:  '1' at: #amount;
		addValue: ' ' at: #weight;
		addValue: ' ' at: #volume ;
		addValue: ' ' at: #goods ;
		yourself.
	
	^(VO new: 'GCServiceDescription' )
		addSvo: route at: #route;
		addSvoStaticList: position at: #transport;
		yourself.
		
! !

!SvoTests class methodsFor: 'scripts' stamp: 'hk 1/26/2015 22:28'!
openSample
	"SvoTests  openSample"
	| adr kontakt  |
	self makeEmail.
	adr := self  makeAdresse .
	kontakt := self makeKontakte  .
	kontakt exec: (AddSvoCopy named:  'adr' on: adr  ).
	^(SvoSpecUI on: kontakt) openWithSpec ; yourself! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 2/5/2015 19:38'!
populateUC1

	| p1 p2 p3 p1Name p2Name p3Name |

	 
	p1 := process copy .
	p2 := process copy .
	p3 := process copy .
	 p1 changeValueOf: #bizFileNo to: '4711' .
	 p1 changeValueOf: #type to: 'internal' .
	 p1 changeValueOf: #status to: 'open' .
	 p1 changeValueOf: #ownership to: 'hartmut' .
	 p1 changeValueOf: #dueDate to: '3.3.2015' .
	 p1Name := (((p1 slots at: #customer) svo slots at: #contactIdentity) svo slots at: #mainContactPerson) svo slots at: #personIdentity.
	p1Name svo changeValueOf: #lastName to: 'Crasemann' .
	p1Name svo changeValueOf: #firstName to: 'Chris W. T. ' .
	
	 p2 changeValueOf: #bizFileNo to: '4712' .
	 p2 changeValueOf: #type to: 'transport land' .
	 p2 changeValueOf: #status to: 'open' .
	 p2 changeValueOf: #ownership to: 'chris' .
	 p2 changeValueOf: #dueDate to: '9.3.2015' .
	 p2Name := (((p2 slots at: #customer) svo slots at: #contactIdentity) svo slots at: #mainContactPerson) svo slots at: #personIdentity.
	p2Name svo changeValueOf: #lastName to: 'Meier' .
	p2Name svo changeValueOf: #firstName to: 'Hans' .
	
	 p3 changeValueOf: #bizFileNo to: '4713' .
	 p3 changeValueOf: #type to: 'transport sea' .
	 p3 changeValueOf: #status to: 'in progress' .
	 p3 changeValueOf: #ownership to: 'chris' .
	 p3 changeValueOf: #dueDate to: '9.2.2015' .
	 p3Name := (((p3 slots at: #customer) svo slots at: #contactIdentity) svo slots at: #mainContactPerson) svo slots at: #personIdentity.
	p3Name svo changeValueOf: #lastName to: 'Montabur' .
	p3Name svo changeValueOf: #firstName to: 'Carl G. ' .
		! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 1/30/2015 13:30'!
tryGloConn
	"self tryGloConn"
	
	self createUC1 .		
	self populateUC1 .
		
	^(GloConnMainUI  onM: gcMainContext onP: gcProcessesContext ) openWithSpec ! !

!SvoTests methodsFor: 'running' stamp: 'hk 1/5/2015 14:06'!
setUp
	self tearDown ! !

!SvoTests methodsFor: 'running' stamp: 'hk 2/3/2015 11:29'!
tearDown
	SvoStorage deleteAllFiles.
	SVO clearSvos .
	SVO allSubclassesDo: [ :cls | cls clearSvos ]
! !

PPCompositeParser subclass: #DslGrammar
	instanceVariableNames: 'action id searchsvos sideEffect searchsvo slotlookup valuelist pathresult pathstart asvo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslGrammar commentStamp: 'hk 12/10/2014 10:45' prior: 0!
A DSLGrammar is the Parser for our SPO-DSL.

Me and my subclasses form a hierarchy where
 - the parsers (rules) are declared 
- the productions are organized. 

The leaves of my subclasss tree constitute different little languages used in different places 

Instance variables: 
	the single parsers
	

PPBrowser open!

!DslGrammar methodsFor: 'grammar' stamp: 'hk 12/1/2014 14:02'!
action
	^id , 'an' asParser trim! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 2/3/2015 17:02'!
asvo
	^id! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 10/27/2014 13:18'!
id
	^ (#letter asParser , #word asParser star) token trim ! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 12/10/2014 13:18'!
pathresult
	^ ( id,  $@ asParser trim,  pathresult) / pathstart! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 12/10/2014 13:05'!
pathstart
	^  id! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 1/21/2015 15:40'!
searchsvo
	^searchsvos ! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 1/21/2015 15:39'!
searchsvos
	^ id, valuelist! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 2/3/2015 17:02'!
sideEffect
	^action , ( searchsvo / asvo )! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 1/21/2015 15:41'!
slotlookup
	^id, $@ asParser trim, (searchsvo / pathresult)! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 12/10/2014 11:19'!
valuelist
	^  '(' asParser trim, id star, ')' asParser trim! !

DslGrammar subclass: #DslSearchParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslSearchParser commentStamp: 'hk 12/10/2014 10:41' prior: 0!
A DslSearchParser class is the abstract compiler carrying all common productions!

DslSearchParser subclass: #DslActionEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslActionEvaluator commentStamp: 'hk 12/3/2014 14:20' prior: 0!
A DSLActionCompiler executes a side effect, a command 
!

!DslActionEvaluator methodsFor: 'rules' stamp: 'hk 11/27/2014 19:02'!
action
	^ super action ==> [ :n | n ifNotNil: [ (n at: 1) inputValue] ] ! !

!DslActionEvaluator methodsFor: 'rules' stamp: 'hk 2/3/2015 17:03'!
asvo
	^ super asvo ==> [ :n | n inputValue ]! !

!DslActionEvaluator methodsFor: 'rules' stamp: 'hk 2/3/2015 16:42'!
sideEffect
	^ super sideEffect ==> [ :n |  VO perform: (n at: 1) asSymbol asMutator with: (n at: 2 ) . 'done' ] ! !

!DslActionEvaluator methodsFor: 'grammar' stamp: 'hk 12/1/2014 14:05'!
start
	^sideEffect end ! !

DslSearchParser subclass: #DslSearchEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslSearchEvaluator commentStamp: 'hk 12/10/2014 11:35' prior: 0!
A DSLSearchCompiler returns a list of results.

typical syntax is:  ASPO ( slotValue { slotvalue-i } ) where
- ASPO is the name of ASPO that contains all searched exemplars
- slotValue is an arbitrary slot value of the hits
- more than 1 slotValue allowed

compile: returns either the desired result or an error string.
The error string may come from 
- PetitParser or
- from the SPO micro services that are used in the productions!

!DslSearchEvaluator methodsFor: 'grammar' stamp: 'hk 1/21/2015 15:41'!
start
	^searchsvos  end ! !

!DslSearchParser class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 10:40'!
frame: aSpo
	^self new propertyAt: #pathFrame put: aSpo; yourself! !

!DslSearchParser methodsFor: 'dsl' stamp: 'hk 12/10/2014 10:37'!
compile:  aSpec
	"answer the parse result or an error string"
	^self parse: aSpec onError: [:msg :pos | (msg, ' at: ', pos printString)] ! !

!DslSearchParser methodsFor: 'rules' stamp: 'hk 1/21/2015 15:40'!
searchsvo
	^super searchsvo ==> [ :n |  VO selectFrom: n] 
	

! !

!DslSearchParser methodsFor: 'rules' stamp: 'hk 1/21/2015 15:40'!
searchsvos
	^super searchsvos ==> [ :n |  VO svoNamesFrom: (n at: 1) inputValue with: (n at: 2) ] ! !

!DslSearchParser methodsFor: 'rules' stamp: 'hk 12/10/2014 11:26'!
valuelist
	^super valuelist ==> [ :n |  (n at: 2) collect: [:a | a inputValue ] ] ! !

DslSearchParser subclass: #DslSlotSearchEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslSlotSearchEvaluator commentStamp: 'hk 12/3/2014 14:28' prior: 0!
A DSLSlotSearchCompiler finds a slot value of a SPO searched. 

typical syntax is:   slotName @ ASPO ( slotValue ), where 
- slotName is the key of the required slot,
- ASPO knows all searched exemplars,
- slotValue is an arbitrary slot value of the hit
!

!DslSlotSearchEvaluator methodsFor: 'rules' stamp: 'hk 1/21/2015 15:33'!
pathresult
	" #pathFrame determines the start of the path"
	
	^super pathresult ==> [ :n |  |spoV node| 
			(n isKindOf: VO) ifTrue: [ n ] ifFalse: 
		 	[((n at: 1) inputValue = 'parent') 
				ifTrue:  [ (node := n at: 3) elder  ifNil: [  self error:   node pName, ' not in a slot' ]  ]
				ifFalse: [ (spoV := (n at: 3) slots at: (n at: 1) inputValue) isSvoSlot 
							ifTrue: [ spoV svo]
							ifFalse: [ self error: 'slot at ', n inputValue, ' not a SPO' ] ] ] ]
			
! !

!DslSlotSearchEvaluator methodsFor: 'rules' stamp: 'hk 2/2/2015 21:01'!
pathstart
	" #pathFrame determines the start of the path"
	
	^super pathstart ==> [ :n |  |spoV node |   (n inputValue = 'parent') 
				ifTrue:  [ (node := self propertyAt: #pathFrame) elder ifNil: [ self error:  node pName, ' not in a slot' ] ]
				ifFalse: [ (spoV := (self propertyAt: #pathFrame) slots at: n inputValue) isSvoSlot 
							ifTrue: [ spoV svo]
							ifFalse: [ self error: 'slot at ', n inputValue, ' not a SVO' ] ]  ]
			
! !

!DslSlotSearchEvaluator methodsFor: 'rules' stamp: 'hk 1/5/2015 19:14'!
slotlookup
	^super slotlookup ==> [ :n |  VO slot: (n at: 1) inputValue of: (n at: 3)  ]! !

!DslSlotSearchEvaluator methodsFor: 'grammar' stamp: 'hk 12/8/2014 10:49'!
start
	^slotlookup end ! !

Object subclass: #AbstractSlot
	instanceVariableNames: 'key frame forDisplay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!AbstractSlot commentStamp: 'hk 12/10/2014 16:44' prior: 0!
I am the abstract class for slot values in the slot dictionary.

No postcopy on frame since that will be done by SPO>>setSlotFrames

Instance Variables
	key:			<Symbol>		my key in the slot dictionary
	frame:			<SPO> 			that I am slot of
!

!AbstractSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 18:09'!
displayString
	^ 'no display string'
	! !

!AbstractSlot methodsFor: 'accessing values' stamp: 'hk 1/20/2015 17:27'!
forDisplay
	^forDisplay ifNil: [ false ]! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 17:27'!
forDisplay: aBoolean
	 forDisplay := aBoolean! !

!AbstractSlot methodsFor: 'private' stamp: 'hk 1/5/2015 15:06'!
frame
	^ frame! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 1/5/2015 15:05'!
frame: aSvo
	frame := aSvo! !

!AbstractSlot methodsFor: 'ui' stamp: 'hk 12/11/2014 14:06'!
index
	^self frame slotSequence indexOf: key! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:24'!
isActionSlot
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:24'!
isConstraintSlot
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 1/19/2015 17:44'!
isDropListSlot
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoDynamicList
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoList
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 13:25'!
isSvoSlot
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:26'!
isValueSlot
	^ false! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 11/7/2014 13:14'!
key
	^key ! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 11/19/2014 13:00'!
key: aString
	key := aString asSymbol! !

!AbstractSlot methodsFor: 'ui' stamp: 'hk 12/14/2014 15:15'!
maxIndex
	^self frame slotSequence size! !

!AbstractSlot methodsFor: 'copying' stamp: 'hk 1/20/2015 17:28'!
postCopy
	forDisplay := forDisplay  copy.! !

!AbstractSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 17:29'!
storeDetailsOn:  aStream
	aStream nextPutAll:  ' forDisplay: ', forDisplay printString, ';' ! !

!AbstractSlot methodsFor: 'serializing' stamp: 'hk 1/5/2015 15:07'!
storeOn:  aStream
	"write the code needed to be instantiated"
	
	aStream 
		nextPut: $( ;
		nextPutAll:  self class name, ' new ';
		nextPutAll: ' key: ', key printString, ';'  ;
		nextPutAll: 'basicFrame: '.
	self frame storeOn: aStream.
	aStream nextPut: $; .
	self storeDetailsOn: aStream.
	aStream nextPutAll: 'yourself)' 
		
	! !

!AbstractSlot methodsFor: 'ui' stamp: 'hk 1/6/2015 13:17'!
uiClass
	"used for a slot display service of a VO (not list display) by the VO"
	
	self subclassResponsibility ! !

AbstractSlot subclass: #ActionSlot
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots'!

!ActionSlot commentStamp: 'hk 12/10/2014 17:12' prior: 0!
I hold a  DSL text that executes an action = side effect.

Instance Variables
	source:		<String>	the DSL source
!

!ActionSlot methodsFor: 'actions' stamp: 'hk 12/11/2014 20:08'!
evaluator
	^DslActionEvaluator frame: self frame! !

!ActionSlot methodsFor: 'actions' stamp: 'hk 2/3/2015 16:48'!
exec  
	^self evaluator compile:  source ! !

!ActionSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:24'!
isActionSlot
	^ true! !

!ActionSlot methodsFor: 'copying' stamp: 'hk 12/9/2014 20:35'!
postCopy
	source := source copy! !

!ActionSlot methodsFor: 'serializing' stamp: 'hk 11/24/2014 21:53'!
printOn:  aStream
	aStream nextPutAll: ' DslSV on: ', source! !

!ActionSlot methodsFor: 'accessing' stamp: 'hk 11/17/2014 14:56'!
source
	^ source ifNil: [ '' ]! !

!ActionSlot methodsFor: 'accessing' stamp: 'hk 11/17/2014 14:55'!
source: aString
	source := aString! !

!ActionSlot methodsFor: 'serializing' stamp: 'hk 12/10/2014 16:45'!
storeDetailsOn:  aStream
	"write the code needed to be instantiated, without Spec vars"
	
	aStream nextPutAll: ' source: ', self source, ';' 
		! !

!ActionSlot methodsFor: 'ui' stamp: 'hk 12/10/2014 17:23'!
uiClass
	^ActionSlotUI  ! !

AbstractSlot subclass: #DropListSlot
	instanceVariableNames: 'list selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!DropListSlot commentStamp: 'hk 1/20/2015 18:50' prior: 0!
I hold a list of strings

Instance Variables
	list:		<List of String>
	selection 	<String> 	the selected item

!

!DropListSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 18:58'!
displayString
	^ self value
	! !

!DropListSlot methodsFor: 'testing' stamp: 'hk 1/19/2015 17:44'!
isDropListSlot
	^ true! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:32'!
list
	^ list ifNil: [ #() ]! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 11/28/2014 10:27'!
list: anObject
	list := anObject! !

!DropListSlot methodsFor: 'copying' stamp: 'hk 1/14/2015 12:23'!
postCopy
	list := self list collect: [ :e | e copy ]! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 18:57'!
selection
	^selection! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 18:53'!
selection: aString
	selection := aString! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 17:31'!
storeDetailsOn:  aStream
	"write the code needed to be instantiated, without Spec vars"

	super storeDetailsOn:  aStream. 
	aStream nextPutAll: ' list: '.
	list storeOn: aStream .
	aStream nextPut: $; .
	! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:40'!
uiClass
	^DropListUI   ! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 18:58'!
value
	^ selection ifNil: [ '' ]! !

AbstractSlot subclass: #SvoList
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!SvoList commentStamp: 'hk 2/2/2015 12:55' prior: 0!
I hold a  list of arbitrary SVO .

Instance Variables
	list:			<List of SVO>		

!

SvoList subclass: #SvoDynamicList
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots'!

!SvoDynamicList commentStamp: 'hk 12/31/2014 18:38' prior: 0!
I hold a dynamic list of SPO .
The list elements are determinded by the DSL text in source 


Instance Variables
	source:		<Object>

!

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:17'!
evaluator
	^DslSearchEvaluator new! !

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 1/5/2015 19:14'!
exec
	| res |
	res := self evaluator compile: self source .
	res isString ifTrue: [ list := #(). ^res ].	
	list := res collect: [ :e | VO at: e ]! !

!SvoDynamicList methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoDynamicList
	^ true! !

!SvoDynamicList methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoList
	^ false! !

!SvoDynamicList methodsFor: 'copying' stamp: 'hk 12/14/2014 11:17'!
postCopy
	"list is filled again with exec"
	source := source copy! !

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:17'!
source
	^source ifNil: [ '' ]! !

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:17'!
source: aString
	source := aString! !

!SvoDynamicList methodsFor: 'serializing' stamp: 'hk 12/14/2014 11:17'!
storeDetailsOn:  aStream
	"write the code needed to be instantiated, without Spec vars"
	
	aStream nextPutAll: ' source: ', self source, ';' 
		! !

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 1/21/2015 16:01'!
uiClass
	^SvoDynamicListUI   ! !

!SvoList methodsFor: 'accessing' stamp: 'hk 1/14/2015 12:05'!
add: aSvo
	^self list add: aSvo
! !

!SvoList methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoList
	^ true! !

!SvoList methodsFor: 'accessing' stamp: 'hk 1/14/2015 12:16'!
list
	^list ifNil: [ list := OrderedCollection new ]
! !

!SvoList methodsFor: 'copying' stamp: 'hk 1/14/2015 13:16'!
postCopy
	list := self list collect: [ :e | e copy ]! !

!SvoList methodsFor: 'ui' stamp: 'hk 1/14/2015 13:36'!
uiClass
	^ SvoListUI ! !

SvoList subclass: #SvoStaticList
	instanceVariableNames: 'templateName accumulators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!SvoStaticList commentStamp: 'hk 12/31/2014 18:39' prior: 0!
I hold a list of all copies of a template.
I can accumulate fields of those copies

Instance Variables
	accumulators:		<List of Symbol>	accumulating slots
	templateName:		<String>!

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 21:28'!
accumulators
	^accumulators ifNil: [ accumulators := OrderedCollection new ] ! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 21:54'!
accumulatorsWithSums
	| coll |
	coll := OrderedCollection new.
	self accumulators do: [ :a | 
		coll add: a.
		coll add: (self valueOf: a) ].
	^coll
	
! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 21:36'!
addAccumulator: aLabel
	self accumulators add: aLabel. ! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 1/5/2015 19:14'!
addExemplar
	| exmpl |
	exmpl := (VO at:  templateName) copy.
	exmpl elder: self frame.
	self refreshList! !

!SvoStaticList methodsFor: 'private' stamp: 'hk 12/14/2014 22:16'!
numberOf: aString
	^Number readFrom: aString ifFail: [ 0 ]! !

!SvoStaticList methodsFor: 'copying' stamp: 'hk 12/14/2014 11:24'!
postCopy
	"list is filled again with exec
	ownSlots are calculated"
	templateName := templateName copy.
	! !

!SvoStaticList methodsFor: 'private' stamp: 'hk 1/8/2015 15:21'!
refreshList
	| exmpls |
	exmpls := (VO at: self templateName ifAbsent: [^self]) copies.
	list := exmpls values collect: [ :e | e  value  ].
! !

!SvoStaticList methodsFor: 'private' stamp: 'hk 12/31/2014 18:43'!
setEntityElders
	self list do: [ :e | e value elder: self frame  ]! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 12:24'!
templateName
	^templateName ifNil: [ '' ]! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 21:11'!
templateName: aPname
	templateName := aPname.
	self refreshList.
	self setEntityElders .
! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:21'!
templateValueSlotKeys
	| spo|
	spo := VO at: self templateName ifAbsent: [ ^#() ].
	^spo valueSlots keys! !

!SvoStaticList methodsFor: 'ui' stamp: 'hk 1/15/2015 14:03'!
uiClass
	^SvoStaticListUI   ! !

!SvoStaticList methodsFor: 'private' stamp: 'hk 12/14/2014 22:18'!
valueOf: accuSymbol
	^self list inject: 0 into: [ :sum :e |
		sum +  (self numberOf: (e valueSlots at: accuSymbol) value) ]! !

AbstractSlot subclass: #SvoSlot
	instanceVariableNames: 'svo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!SvoSlot commentStamp: 'hk 2/2/2015 12:51' prior: 0!
I hold a single SPO in a SpoProxy

Instance Variables
	svo:		<SVO>		 the SVO that I contain
!

!SvoSlot methodsFor: 'private' stamp: 'hk 1/21/2015 15:34'!
basicSvo
	^ svo! !

!SvoSlot methodsFor: 'private' stamp: 'hk 1/21/2015 15:34'!
basicSvo: aSpoProxy
	svo := aSpoProxy! !

!SvoSlot methodsFor: 'serializing' stamp: 'hk 1/21/2015 15:33'!
displayString
	^ self svo ifNil: [ ^'' ]  ifNotNil: [ self svo displayString ]! !

!SvoSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 13:25'!
isSvoSlot
	^ true! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 1/21/2015 15:33'!
pName
	^ self svo pName! !

!SvoSlot methodsFor: 'copying' stamp: 'hk 1/5/2015 15:09'!
postCopy
	svo :=  svo  copy ! !

!SvoSlot methodsFor: 'printing' stamp: 'hk 1/5/2015 15:09'!
printOn:  aStream
	super printOn: aStream.
	aStream nextPutAll:  ' on: ', svo pName! !

!SvoSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 17:31'!
storeDetailsOn:  aStream
	super storeDetailsOn:  aStream. 
	aStream nextPutAll: 'basicSpo: '.
	svo storeOn: aStream.
	aStream nextPut: $; .

! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 2/2/2015 12:51'!
svo
	^ svo! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 1/21/2015 15:33'!
svo: aSvo
	svo := aSvo
! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 1/21/2015 15:33'!
svoDisplayValues
	| coll |
	coll := OrderedCollection new.
	self svo slotSequence do: [ :k | | slot|
		(slot := self svo slots at: k) forDisplay ifTrue: [ coll add: slot ] ].
	^coll
	
  ! !

!SvoSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 13:30'!
uiClass
	^ SvoEmbeddedUI ! !

AbstractSlot subclass: #ValueSlot
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!ValueSlot commentStamp: 'hk 12/10/2014 17:17' prior: 0!
I hold a string attribute

Instance Variables
	forDisplay:		<Boolean> 		true if this slot is used in UI lists
	value:			<String>

!

ValueSlot subclass: #DslValueSlot
	instanceVariableNames: 'source origin originalKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots'!

!DslValueSlot commentStamp: 'hk 12/10/2014 17:19' prior: 0!
I am a ValueSlot that is filled by executing a piece of DSL

storeOn: und postCopy for origin & originaslKey ?

Instance Variables
	source:			<String>		DSL source
	origin: 			< String>		origin pName
	originalKey: 	< String>		key at origin 
			


!

!DslValueSlot methodsFor: 'ui-actions' stamp: 'hk 12/11/2014 20:06'!
evaluator
	^DslSlotSearchEvaluator frame: self frame! !

!DslValueSlot methodsFor: 'ui-actions' stamp: 'hk 12/11/2014 20:06'!
exec
	| slot res |  
	res := self evaluator compile: self source . 
	res isString ifTrue: [ value := res. ^self  ] .
	slot := res copy.
	originalKey := slot key.
	value := slot value.
	origin := slot frame pName
	! !

!DslValueSlot methodsFor: 'testing' stamp: 'hk 1/26/2015 11:35'!
isActionSlot
	^ true! !

!DslValueSlot methodsFor: 'accessing' stamp: 'hk 12/2/2014 16:55'!
originalKey
	^originalKey ifNil: [ '' ]! !

!DslValueSlot methodsFor: 'copying' stamp: 'hk 12/9/2014 20:34'!
postCopy
"originalKey & origin are filled anew on exec"
	super postCopy.
	source := source copy! !

!DslValueSlot methodsFor: 'serializing' stamp: 'hk 12/3/2014 15:04'!
printOn:  aStream
	aStream nextPutAll: 'DslValueSV on: ', value printString! !

!DslValueSlot methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:01'!
source
	^source ifNil: [ '' ]! !

!DslValueSlot methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:01'!
source: aString
	source := aString! !

!DslValueSlot methodsFor: 'serializing' stamp: 'hk 12/10/2014 16:55'!
storeDetailsOn:  aStream
	"write the code needed to be instantiated, without Spec vars"

	super storeDetailsOn: aStream .
	aStream nextPutAll: ' source: ', self source printString, ';' ! !

!DslValueSlot methodsFor: 'ui' stamp: 'hk 12/10/2014 17:21'!
uiClass
	^DslValueSlotUI ! !

!ValueSlot methodsFor: 'testing' stamp: 'hk 11/23/2014 13:28'!
contains: aString
	^ aString  = value  ! !

!ValueSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 17:52'!
displayString
	^self value
	! !

!ValueSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:26'!
isValueSlot
	^ true! !

!ValueSlot methodsFor: 'copying' stamp: 'hk 1/20/2015 17:28'!
postCopy
	value := value copy.
! !

!ValueSlot methodsFor: 'serializing' stamp: 'hk 12/3/2014 13:21'!
printOn:  aStream
	aStream nextPutAll: ' ValueSV on: ', value printString! !

!ValueSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 17:31'!
storeDetailsOn:  aStream
	super storeDetailsOn:  aStream. 
	aStream nextPutAll:  ' value: ', value printString, ';' ! !

!ValueSlot methodsFor: 'ui' stamp: 'hk 1/6/2015 13:05'!
uiClass
	^ValueUI   ! !

!ValueSlot methodsFor: 'accessing' stamp: 'hk 11/23/2014 13:31'!
value
	^value ifNil: [ '' ]! !

!ValueSlot methodsFor: 'accessing' stamp: 'hk 11/23/2014 13:34'!
value: aString
	value := aString! !

Object subclass: #Command
	instanceVariableNames: 'reverseBlock actionBlock receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!Command commentStamp: 'hk 11/18/2014 13:48' prior: 0!
A Command is used in between saves editing a SPO.
The command stack of a SPO is used for undo.
I can hold a SPO since I am not stored - no danger of cycles

Instance Variables
	actionBlock:	<Block>
	reverseBlock:	< Block>		for undo
	receiver:		<SPO>			that executes the command
!

!Command methodsFor: 'copying' stamp: 'hk 11/13/2014 17:04'!
deepCopy
	"don't copy a command"! !

!Command methodsFor: 'executing' stamp: 'hk 11/4/2014 09:13'!
do
	"prepare my blocks,
	execute the command"! !

!Command methodsFor: 'accessing' stamp: 'hk 11/3/2014 15:58'!
receiver: aSPO
	receiver := aSPO ! !

!Command methodsFor: 'executing' stamp: 'hk 11/4/2014 08:58'!
redo
	actionBlock value! !

!Command methodsFor: 'serializing' stamp: 'hk 12/10/2014 17:28'!
storeOn: aStream 
	"PRE: commands are never stored"! !

!Command methodsFor: 'executing' stamp: 'hk 11/4/2014 08:58'!
undo
	reverseBlock value! !

Command subclass: #SlotCommand
	instanceVariableNames: 'slotKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!SlotCommand commentStamp: 'hk 11/19/2014 12:59' prior: 0!
A SlotCommand is a Command for SPO slots 

Instance Variables
	slotKey:	<Symbol>		key of the slot
!

SlotCommand subclass: #AddAction
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddAction commentStamp: 'hk 12/10/2014 17:40' prior: 0!
I am a SlotCommand that adds an ActionSlot to my receiver

Instance Variables
	source:		<String>		DSL source!

!AddAction class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:47'!
named: aName source: aString 
	^(self named: aName)
		source: aString;
		yourself! !

!AddAction methodsFor: 'executing' stamp: 'hk 12/4/2014 18:33'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [receiver addMethod:   source at: slotKey].
	actionBlock value! !

!AddAction methodsFor: 'accessing' stamp: 'hk 11/3/2014 14:58'!
source: anObject
	source := anObject! !

SlotCommand subclass: #AddListOfStrings
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddListOfStrings commentStamp: 'hk 11/28/2014 16:38' prior: 0!
An AddList is xxxxxxxxx.

Instance Variables
	list:		<Collection>!

!AddListOfStrings class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:47'!
named: aName list: aList 
	^(self named: aName )	
		list: aList;
		yourself! !

!AddListOfStrings methodsFor: 'executing' stamp: 'hk 12/4/2014 18:01'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [ receiver  addValueList: self list at: slotKey ].
	actionBlock value! !

!AddListOfStrings methodsFor: 'accessing' stamp: 'hk 11/28/2014 16:45'!
list
	^ list! !

!AddListOfStrings methodsFor: 'accessing' stamp: 'hk 11/28/2014 16:32'!
list: anObject
	list := anObject! !

SlotCommand subclass: #AddSpoDynamicList
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddSpoDynamicList commentStamp: 'hk 11/27/2014 18:36' prior: 0!
An AddSpoList is xxxxxxxxx.

Instance Variables
	source:		<String>!

!AddSpoDynamicList class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:48'!
named: aName source: aString 
	^(self named: aName )
		source: aString;
		yourself! !

!AddSpoDynamicList methodsFor: 'executing' stamp: 'hk 1/14/2015 11:17'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [receiver addSvoDynamicList: source at: slotKey ].
	actionBlock value! !

!AddSpoDynamicList methodsFor: 'accessing' stamp: 'hk 11/27/2014 18:43'!
source: aString
	source := aString! !

SlotCommand subclass: #AddSpoStaticList
	instanceVariableNames: 'template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddSpoStaticList commentStamp: 'hk 12/14/2014 14:04' prior: 0!
I add a static spo list

Instance Variables
	template:		<String>!

!AddSpoStaticList class methodsFor: 'as yet unclassified' stamp: 'hk 12/14/2014 14:05'!
named: aName template: aSpoPname
	^(self named: aName )
		template: aSpoPname;
		yourself! !

!AddSpoStaticList methodsFor: 'accessing' stamp: 'hk 1/14/2015 11:17'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [receiver addSvoStaticList: (VO at: template) at: slotKey ].
	actionBlock value! !

!AddSpoStaticList methodsFor: 'accessing' stamp: 'hk 1/17/2015 18:33'!
template
	^ template ifNil: [ '' ]! !

!AddSpoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 14:05'!
template: anObject
	template := anObject! !

!AddSpoStaticList methodsFor: 'accessing' stamp: 'hk 1/5/2015 19:14'!
templateSpo
	^VO at: template! !

SlotCommand subclass: #AddSvoCopy
	instanceVariableNames: 'svo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddSvoCopy commentStamp: 'hk 1/30/2015 12:19' prior: 0!
An AddSPO is a SlotCommand

Instance Variables
	svo:		<SVO>		the SVO inserted (always a copy)

!

!AddSvoCopy class methodsFor: 'instance creation' stamp: 'hk 1/30/2015 12:19'!
named: aName on: aSvo 
	^(self new) 
		slotKey: aName;
		svo: aSvo copy ;
		yourself! !

!AddSvoCopy methodsFor: 'executing' stamp: 'hk 1/26/2015 22:19'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [	 receiver addSvo: svo at: slotKey].
	actionBlock value! !

!AddSvoCopy methodsFor: 'initialize - release' stamp: 'hk 1/30/2015 12:18'!
receiver: aSvo
	receiver := aSvo .
	svo elder: aSvo

! !

!AddSvoCopy methodsFor: 'initialize - release' stamp: 'hk 1/30/2015 12:18'!
svo: aSvo
	svo := aSvo ! !

AddSvoCopy subclass: #CopyAsvo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!CopyAsvo commentStamp: 'hk 1/30/2015 12:43' prior: 0!
I add the spo to exemplars (in list view).
The slotKey is not used, since no slot is used.
!

!CopyAsvo class methodsFor: 'instance creation' stamp: 'hk 1/30/2015 12:23'!
on:  aReceiver
	| cp |
	cp := aReceiver copy.
	^(self new) 
		slotKey: cp pName;
		svo: cp ;
		yourself! !

!CopyAsvo methodsFor: 'executing' stamp: 'hk 1/26/2015 22:19'!
do
	reverseBlock := [receiver removeCopy: svo pName ].
	actionBlock := [receiver addCopy: svo.].
	actionBlock value! !

!CopyAsvo methodsFor: 'executing' stamp: 'hk 1/26/2015 22:20'!
receiver: aSvo
	receiver := aSvo ! !

AddSvoCopy subclass: #RemoveSvoCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!RemoveSvoCopy commentStamp: 'hk 1/30/2015 12:43' prior: 0!
I remove the copy named in list view.
The slotKey holds the pName, only used for undo

!

!RemoveSvoCopy methodsFor: 'as yet unclassified' stamp: 'hk 1/26/2015 22:19'!
do
	reverseBlock := [receiver addCopy: svo].
	actionBlock := [svo :=  receiver removeCopy: slotKey ].
	actionBlock value! !

!RemoveSvoCopy methodsFor: 'as yet unclassified' stamp: 'hk 1/26/2015 22:20'!
receiver: aSvo
	receiver := aSvo ! !

SlotCommand subclass: #AddValue
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddValue commentStamp: 'hk 11/19/2014 12:56' prior: 0!
An AddValue is a SlotCommand

Instance Variables
	value:		<Srtring>		the slot content

!

AddValue subclass: #AddDslValue
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddDslValue commentStamp: 'hk 12/2/2014 19:32' prior: 0!
An AddValueDsl is xxxxxxxxx.

Instance Variables
	source:		<String>!

!AddDslValue class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:48'!
named: aName source: aString 
	^(self named: aName )
		source: aString;
		yourself! !

!AddDslValue methodsFor: 'executing' stamp: 'hk 12/4/2014 18:24'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [ receiver addValueDsl: self source at: slotKey].
	actionBlock value! !

!AddDslValue methodsFor: 'accessing' stamp: 'hk 12/2/2014 19:32'!
source
	^source ifNil: [ '' ]! !

!AddDslValue methodsFor: 'accessing' stamp: 'hk 12/2/2014 19:32'!
source: aString
	source := aString! !

!AddValue class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:48'!
named: aName value: aString 
	^(self named: aName )	
		value: aString;
		yourself! !

!AddValue methodsFor: 'executing' stamp: 'hk 12/4/2014 18:03'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [ receiver  addValue: self value at: slotKey].
	actionBlock value! !

!AddValue methodsFor: 'accessing' stamp: 'hk 11/11/2014 15:53'!
value
	^value ifNil: [ '' ]! !

!AddValue methodsFor: 'accessing' stamp: 'hk 11/11/2014 15:46'!
value: aString
	value := aString! !

SlotCommand subclass: #MoveDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!MoveDown commentStamp: 'hk 11/19/2014 12:56' prior: 0!
A MoveDown is a SlotCommand
!

!MoveDown methodsFor: 'executing' stamp: 'hk 11/18/2014 13:46'!
do
	reverseBlock := [receiver moveUp: slotKey ].
	actionBlock := [receiver moveDown: slotKey ].
	actionBlock value! !

SlotCommand subclass: #MoveUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!MoveUp commentStamp: 'hk 11/19/2014 12:56' prior: 0!
A MoveUp  is a SlotCommand
!

!MoveUp methodsFor: 'executing' stamp: 'hk 11/18/2014 13:47'!
do
	reverseBlock := [receiver moveDown: slotKey ].
	actionBlock := [receiver moveUp: slotKey ].
	actionBlock value! !

SlotCommand subclass: #RemoveSlot
	instanceVariableNames: 'theSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!RemoveSlot commentStamp: 'hk 11/19/2014 12:55' prior: 0!
A RemoveSlot is a SlotCommand

Instance Variables
	theSlot:		<SlotValue>		the one removed!

!RemoveSlot methodsFor: 'executing' stamp: 'hk 11/19/2014 12:54'!
do
	reverseBlock := [receiver addSlot: theSlot].
	actionBlock := [theSlot :=  receiver removeSlot: slotKey ].
	actionBlock value! !

!SlotCommand class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:45'!
named: aName 
	^(self new)	
		slotKey:  aName ;
		yourself! !

!SlotCommand methodsFor: 'accessing' stamp: 'hk 12/15/2014 21:04'!
slotKey: aString    
	slotKey := aString asSymbol! !

Object subclass: #SVO
	instanceVariableNames: 'version slots slotSequence pName undoStack redoStack announcer deleted copies template elder isAsvo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

SVO class
	instanceVariableNames: 'svos'!

!SVO commentStamp: 'hk 1/26/2015 11:37' prior: 0!
I am an abstract Smart Value Object. I come in four different flavours: 
- VO: value objects, that carry only data, plus eventually constraints
- RO: role objects (in the sense of DCI) that carry behaviour
- CO: constraint objects 
- UC: useCase context objects (in the sense of DCI) that know its roles and trigger. 

I have slots like a Frame, which are treated uniformly. My slots can be (for all types):
- ValueSlot				holds a string 
- ActionSlot				holds a dsl method 
- ValueListSlot 			holds a list of predefined strings
- SvoSlot 				holds a  SVO. This is essential for the SVO's structure
- SvoListSlot				holds a  list of SVO 


Unique key is my pName = my persistent name in the file system, together with my version.

I know two copy operations:
- cloning results in a new name & fresh version. Used for authoring only.
- copying is the normal operation at runtime.
An application is programmed by authoring its SVO. These SVO then become ASVO - in order to be frozen (after cloning). 
A Copy can be made from a SVO or an ASVO. The pName of the copy is created by extending the original (template) pName. The original SVO (or ASVO) serves as a container for all its copies. Each copy knows the pName of its template.

Each SVO may be constructed in form of a tree of other SVO, held in special slots. This whole tree is a unique entity - the entity tree. The elder holds the parent node, slots the child nodes.  Whenever a new version of a node is saved, all its parent nodes up to the root of the tree must be saved with new version as well. This way the version of the root node denotes the version of the whole entity.
			
Instance Variables (all lazy)
	pName:			<String>				persistent name	
	deleted: 		<Boolean>				flag relevant for last version	
	version:			<String>				starts with '0' 
	template:		<VO>					my copy  source 
	elder:			<VO>					my entity parent node
	copies: 			<Dictionary>				of all SVO that are copied from me
	slots:			<Dictionary of SlotValue>	for fast access
	slotSequence:	<OrderedCollection> 	of the slot keys 
	isAsvo: 			<Boolean>				only true for templates
GUI related instance variables:			
	undoStack:		<OrderedCollection of Command>		for undo
	redoStack:		<OrderedCollection of Command>		for redo
	announcer: 		<SvoAnnouncer>						for the GUI
											
Class instance variables
	svos			<Dictionary of SVO>	pname -> SVO, holds all SVO of my type!

SVO class
	instanceVariableNames: 'svos'!

SVO subclass: #CF
	instanceVariableNames: 'roles context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!CF commentStamp: 'hk 2/2/2015 13:22' prior: 0!
I am a ACM Case Folder or DCI Context.
Any business knows at least three types:
- BizCF  the offering and billing CF 
- FfdCF  the Fulfilment and Delivery CF
- ContCF  the Controlling CF

I may be 
- a normal context or
- a list contect. 

I statically know my role objects (or rule objects) in a SvoList slot named #rules.
I dynamically know all VO that are associated to me in another SvoList slot named #values.

Context objects, roles etc. are NO !!!! parts of myself.
Indeed I only hold references to them.
Instance Variables
	context:	<Collection of VO>
	roles:		<Collection of RO>!

!CF methodsFor: 'accessing roles' stamp: 'hk 2/2/2015 13:24'!
addRo: aRO
	self roles add: aRO.
	^aRO! !

!CF methodsFor: 'accessing context' stamp: 'hk 2/2/2015 13:25'!
addVo: aVO
	self context add: aVO.
	^aVO! !

!CF methodsFor: 'accessing context' stamp: 'hk 2/2/2015 14:53'!
context
	"answer a coll of my VO "
	^context ifNil: [ context := Set new ]! !

!CF methodsFor: 'accessing roles' stamp: 'hk 2/2/2015 14:52'!
roles
	"answer a coll of my RO objects"
	^roles ifNil: [ roles := Set new ]! !

CF subclass: #CFlist
	instanceVariableNames: 'asvo subContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!CFlist commentStamp: 'hk 2/5/2015 12:41' prior: 0!
I am a list context,
bound to a template.
Thus I know all its copies.
I also know  many context VOs

Instance Variables
	asvo:			<ASVO>		my template
	subContext: 	<CFplain>
!

!CFlist methodsFor: 'accessing template' stamp: 'hk 2/2/2015 13:31'!
asvo
	^asvo ifNil: [ self error: self pName, ' has no template' ]! !

!CFlist methodsFor: 'accessing template' stamp: 'hk 2/2/2015 14:57'!
asvo: anASVO
	asvo := anASVO! !

!CFlist methodsFor: 'accessing template' stamp: 'hk 2/4/2015 17:56'!
list
	^self asvo copies values ! !

!CFlist methodsFor: 'accessing - subContext' stamp: 'hk 2/5/2015 12:42'!
subContext
	^subContext ! !

!CFlist methodsFor: 'accessing - subContext' stamp: 'hk 2/5/2015 12:41'!
subContext: aCFplain
	subContext := aCFplain! !

!CFlist methodsFor: 'accessing - subContext' stamp: 'hk 2/5/2015 12:50'!
subContextDo: aBlock
	^subContext ifNotNil: [ aBlock value ]! !

CF subclass: #CFplain
	instanceVariableNames: 'vo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!CFplain commentStamp: 'hk 2/2/2015 13:33' prior: 0!
I am a normal (plain) context,
bound to one VO,
knowing many context VOs

Instance Variables
	vo:		<VO>		for which I define the context

!

!CFplain methodsFor: 'accessing' stamp: 'hk 2/2/2015 13:28'!
vo
	^vo ifNil: [ self error: self pName, ' has no VO' ]! !

!CFplain methodsFor: 'accessing' stamp: 'hk 2/5/2015 13:51'!
vo: aVO
	vo := aVO! !

SVO subclass: #CO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!CO commentStamp: 'hk 1/8/2015 14:26' prior: 0!
I am a Constraint Object. !

SVO subclass: #RO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!RO commentStamp: 'hk 1/14/2015 11:20' prior: 0!
I am a Role Object. My slot types are the inherited ones plus:
- ActionSlot				holds a DSLmethod 
				

!

!RO methodsFor: 'accessing actions' stamp: 'hk 1/26/2015 11:40'!
actionSlots
	^self dslSlots! !

!RO methodsFor: 'testing' stamp: 'hk 1/26/2015 14:17'!
hasMenu
	^self actionSlots isNotEmpty! !

!RO methodsFor: 'ui app' stamp: 'hk 2/3/2015 16:52'!
menu
	|  actions  |
	self hasMenu ifFalse: [ ^nil ] .
	(actions := self actionSlots)  size = 1
		ifTrue: [ ^ MenuItemModel new	
						name: actions keys anyOne ;
						action: [ actions values anyOne exec inspect] ;
						yourself ] .
	^MenuItemModel new	
		name: self pName ; 
		subMenu: (MenuModel new addGroup: [ :g | 
					actions keysAndValuesDo: [ :k :v | 
						g addItem: [ :i | i name: k ; action: [ v exec ] ] ] ] ) ;
		yourself .! !

!RO methodsFor: 'ui app' stamp: 'hk 2/4/2015 18:57'!
menu: aBlock
	|  actions  |
	self hasMenu ifFalse: [ ^nil ] .
	(actions := self actionSlots)  size = 1
		ifTrue: [ ^ MenuItemModel new	
						name: actions keys anyOne ;
						action: [ actions values anyOne exec . aBlock value] ;
						yourself ] .
	^MenuItemModel new	
		name: self pName ; 
		subMenu: (MenuModel new addGroup: [ :g | 
					actions keysAndValuesDo: [ :k :v | 
						g addItem: [ :i | i name: k ; action: [ v exec ] ] ] ] ) ;
		yourself .! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/30/2015 11:44'!
addSvo: aSvo			
	self svos at: aSvo pName ifPresent: [ self inform: aSvo pName, ' overwritten'] .
	self svos add: aSvo pName -> aSvo. 
	^aSvo 
	
! !

!SVO class methodsFor: 'helpers' stamp: 'hk 1/7/2015 13:58'!
alert: errorString
	"the system wide alert dialog"

	WidgetExamples new exampleBuilder alert: errorString! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 1/7/2015 15:33'!
allSvoNames
	^self svos values collect: [ :svo | svo pName ]! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/7/2015 14:00'!
at: aName
	^ self svos at: aName ifAbsent: [ nil ]! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/7/2015 14:00'!
at: aName ifAbsent: absentBlock
	^ self svos at: aName ifAbsent: absentBlock! !

!SVO class methodsFor: 'helpers' stamp: 'hk 1/7/2015 13:58'!
chooseFrom: aColl mess: aMessage
	"answers 0 or the index of the users choice in aColl
	<SPO chooseFrom: #(a b c) mess: 'choose one' >"
		
	^UIManager default chooseFrom: aColl asOrderedCollection lines: #() message: aMessage! !

!SVO class methodsFor: 'helpers' stamp: 'hk 1/7/2015 13:58'!
chooseValueFrom: aColl mess: aMessage
		"answers nil or the element of the users choice in aColl
		<SPO chooseValueFrom: #(a b c) mess: 'choose one'> "
		
	| coll index |
	coll := aColl asOrderedCollection.
	index :=  self chooseFrom: coll mess: aMessage.
	index = 0 ifTrue: [ ^nil ].
	^coll at: index

	! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/8/2015 14:50'!
clearSvos
	svos := nil! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 2/3/2015 17:07'!
copy:  aVoName
	"do the action. answer a string with the actions result
	depends on the existence of an Email ASPO"

	( VO at: aVoName ifAbsent: [^ aVoName, ' not found' ] ) copy 
	
! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 2/3/2015 16:35'!
email:  aVoName
	"do the action. answer a string with the actions result
	depends on the existence of an Email ASPO"

	| email address | 
	email := ( VO at: #Email ifAbsent: [^ 'Email not found' ] ) copy .
	address := ((VO at: aVoName ifAbsent: [ ^aVoName  ] ) slots at: #email) value.
	(email slots at: #an) value: address.
	email edit.
	^ 'done'

! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 2/3/2015 16:35'!
neueTour:  aVoName
	"do the action. answer a string with the actions result
	depends on the existence of an Email ASPO"

	| tour key | 
	key := ((VO at: aVoName ifAbsent: [ ^aVoName ] ) slots at: #id) value.
	tour := ( VO at: #GloConnTour ifAbsent: [^ 'GloConnTour not found' ] ) copy .
	tour changeValueOf: #vorgang to: key.
	^ 'done'

! !

!SVO class methodsFor: 'instance creation' stamp: 'hk 1/12/2015 17:15'!
new: aName
	(self = SVO) ifTrue: [ ^self error: 'SVO is an abstract class' ] .
	^self addSvo:  (self new pName: aName; beAsvo).
! !

!SVO class methodsFor: 'helpers' stamp: 'hk 1/7/2015 13:58'!
question: aMessage title: aTitle
	"answers 0 or the index of the users choice in aColl
	<GCService chooseFrom: #(a b c) mess: 'choose one' >"
		
	^UIManager default question: aMessage title: aTitle! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 1/7/2015 13:58'!
selectFrom: aCollOrString
	"answer the only or user selected emelemt of aColl. or an error string"

	aCollOrString isString ifTrue: [ ^aCollOrString  ].
	aCollOrString size = 1 ifTrue: [ ^ aCollOrString anyOne ].
	^ (self chooseValueFrom: aCollOrString mess: 'select SPO')  
			ifNil: [ ^' aborted by user  ' ] ! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 1/7/2015 15:32'!
slot: slotName of: SvoOrName
	"answer the slot or an error msg. the compiler calls this with SvoOrName = aString & aSvo"
	| spo |
	spo := SvoOrName.
	(spo isKindOf: String) ifTrue:  [ spo := self at: SvoOrName ifAbsent: [ ^ 'error: ', SvoOrName ]  ].
	^spo slots at: slotName ifAbsent: [ ^ 'error: ', slotName ]! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 1/7/2015 15:27'!
svoNamesFrom: aSvoName with: aSlotValueArray
	"answer an error string or a Coll with all names of aSvoName copies that contain the values of aSlotValueArray in its slots"

	| results  |   
	results := (self at: aSvoName ifAbsent: [ ^aSvoName, ' not found' ] )
		copiesColl select: [ :e |  aSlotValueArray allSatisfy: [ :sv |  e value hasValue: sv ] ].  
	results ifEmpty: [ ^aSlotValueArray printString, ' not found'  ].
	^results collect: [ :e | e pName ]
	! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/7/2015 14:00'!
svos
	^ svos ifNil: [ svos := Dictionary new ]! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 1/7/2015 14:06'!
valueNamed: aKey of: aPName
	"answer the value of slot aKey of aPName or signal an error"

	| aspo | 
	aspo := self at: aPName ifAbsent: [ ^nil ] .
	^ aspo valueSlots at: aKey ifAbsent: 
		[ aspo valueSlots at: aKey ifAbsent: 
			[ ^self alert: aKey , ' not found in ' , aPName ] ]! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 1/30/2015 12:48'!
addCopy: aSvo
	self copies add: aSvo pName ->  aSvo.
	self class at: aSvo pName ifAbsent: [ self class addSvo:  aSvo].  "on undo the copy must be registered again"
	self announcer announce: SlotsChanged new.
	^aSvo ! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/7/2015 13:57'!
addMethod:  aString at: slotName
	^self addSlot:  (ActionSlot new
				frame: self;
				key: slotName;
				source: aString ;
				yourself  )! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/7/2015 13:57'!
addSlot: aSlot
	"insert the ready made slot "
	| new |
	(self slotSequence includes: aSlot key) 
		ifTrue: [ self error: 'slot already exists' ].
	self slotSequence add: aSlot key.
	new := self slots add: (aSlot key -> aSlot).
	self announcer announce: SlotsChanged new.
	^new value
! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/21/2015 15:33'!
addSvo: aSvo at: slotName
	"put aSvo in this spo slot"
	aSvo elder: self .
	^self addSlot: (	(SvoSlot new
					frame: self;
					key: slotName;
					svo: aSvo ;
					yourself))! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/14/2015 11:48'!
addSvoDynamicList: aSource at: slotName
	^self addSlot: (	(SvoDynamicList new
					frame: self;
					key: slotName;
					source: aSource ;
					yourself))! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/14/2015 11:48'!
addSvoListAt: slotName
	^self addSlot: (	(SvoList new
					frame: self;
					key: slotName;
					yourself))! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/14/2015 11:48'!
addSvoStaticList: aSvo at: slotName
	^self addSlot: (	(SvoStaticList new
					frame: self;
					key: slotName;
					templateName: (aSvo ifNil: [ nil ] ifNotNil: [aSvo pName]) ;
					yourself))! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 2/2/2015 18:00'!
addValue: aString at: slotName
	^self addValue: aString at: slotName forDisplay: false! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/7/2015 13:57'!
addValue:  aString at: slotName forDisplay: aBoolean
	^self addSlot:  (ValueSlot new 
						frame: self;
						key: slotName;
						value: aString;
						forDisplay: aBoolean ;
						yourself)! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/7/2015 13:57'!
addValueDsl:  sourceString at: slotName
	^self addSlot:  (DslValueSlot new 
						frame: self;
						key: slotName;
						source: sourceString ;
						yourself)! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/19/2015 17:38'!
addValueList: listOfString at: slotName
		^self addSlot:  (DropListSlot new 
						frame: self;
						key: slotName;
						list: listOfString;
						yourself)! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 14:02'!
addYourself
	self class addSvo: self! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
alert: aString
	self class alert: aString! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
announcer
	^announcer ifNil: [ announcer := SvoAnnouncer new ]! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/12/2015 17:14'!
beAsvo
	isAsvo := true
! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/12/2015 17:14'!
beSvo
	isAsvo := false
! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/27/2015 14:34'!
change: slotName forDisplay: aBoolean
	| slot | 
	slot := self slots at: slotName ifAbsent: [ ^self ].	
	slot forDisplay: aBoolean ! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/27/2015 14:37'!
changeValueOf: slotName to: aString
	| slot | 
	slot := self valueSlots at: slotName ifAbsent: [ ^self ].	
	slot value: aString! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
clearCommandStacks
	undoStack := nil.
	redoStack := nil.
! !

!SVO methodsFor: 'copying' stamp: 'hk 1/12/2015 17:20'!
clone: newName
	"answer a copy of myself with a new name and a fresh version"
	| child |
	(self class svos includesKey: newName) ifTrue: 
		[^self error: ('SVO ', newName, ' already exists' )].
	^child := self copy 
				pName: newName;
				resetVersion;
				beAsvo; 
				save
	! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 1/7/2015 13:57'!
closeWindow
	self announcer announce: CloseFrame  new.
 ! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
constraintSlots
	^ self slots select: [ :v | v isConstraintSlot]! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 1/7/2015 13:57'!
copies
	^ copies ifNil: [ copies := Dictionary new ]! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 1/7/2015 13:57'!
copiesColl
	^ self copies values asOrderedCollection! !

!SVO methodsFor: 'copying' stamp: 'hk 1/12/2015 17:21'!
copy
	"answer a new exemplar = value of myself "
	| child |
	(child := self class new template: self ).
	self copySlotsTo: child.
	child 	pName: (pName, '_', (1 + self copies size) asString ) ;
			beSvo;
			addYourself; 
			save . 
	^self addCopy: child ! !

!SVO methodsFor: 'copying' stamp: 'hk 1/8/2015 15:33'!
copySlotsTo: child
	"copy the slots in sequence. pName is required "
	child 
		slots: self slotsCopy ; setSlotFrames ;		
		slotSequence: self slotSequence copy ! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 14:00'!
delete
	"I cannot be deleted with exemplars"

	self copies isEmpty
		ifFalse: [ 
			self alert: 'cannot delete with exemplars'.
			^ false ].

	self class svos removeKey: self pName ifAbsent: [  ].
	self deleteFile.
	^ true! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
deleteFile
	"just mark to be deleted"
	
	deleted := true.         
	self save ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:25'!
deleted
	^deleted isNotNil! !

!SVO methodsFor: 'printing' stamp: 'hk 2/3/2015 16:01'!
displayArray
	| ar |     
	ar := OrderedCollection  new.
	self slotsDo: [:s | s forDisplay ifTrue: [ ar add: s displayString ] ].
	 ^ar! !

!SVO methodsFor: 'printing' stamp: 'hk 2/3/2015 15:39'!
displayLabelArray
	| ar |     
	ar := OrderedCollection  new.
	self slotsDo: [:s | s forDisplay ifTrue: [ ar add: s key asSymbol] ].
	 ^ar! !

!SVO methodsFor: 'printing' stamp: 'hk 1/20/2015 18:01'!
displayString
	| str |
	str := ''.
	self slotsDo: [:s | s forDisplay ifTrue: [ str := str, ' ', s displayString ] ].
	 ^str! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/27/2015 11:03'!
dslSlots
	^ self slots select: [ :v | v isActionSlot]! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 1/14/2015 13:29'!
edit   
 	^( SvoSpecUI on: self) openWithSpec! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
elder
	^elder ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
elder:  aSvo
	elder :=  aSvo! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
elderName
	^self elder ifNotNil: [ self elder pName ] ifNil: [ '' ]! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:10'!
elderVersion
	^self elder ifNil: [ '' ] ifNotNil: [self elder version ]

		
	! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 13:57'!
exec: aCommand
	aCommand receiver: self.
	self undoStack add: aCommand do.		! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 2/2/2015 18:50'!
exemplarsAsCollOfPairs
	"answer the exemplars as a CollectionOfPairs that understand pairsDo:
	the spo must be wrapped in a slot "

	| coll |
	coll := OrderedCollection new.
	self copiesColl do: [ :spo |  | sv |
			coll add: spo pName .
			sv := SvoSlot new 
						frame: self; 
						key: spo pName ;
						svo: spo value ;
						yourself.
			coll add: (CommonSlotUI  on: sv type: SvoUI ) ].					
	^ coll! !

!SVO methodsFor: 'file handling' stamp: 'hk 1/8/2015 15:10'!
fileName
	^self pName , '-v', self version, '.', self  fileType ! !

!SVO methodsFor: 'file handling' stamp: 'hk 1/7/2015 13:57'!
fileType
	^self isAsvo ifTrue: ['aspo'] ifFalse: ['dspo']! !

!SVO methodsFor: 'protocol - testing' stamp: 'hk 1/7/2015 13:57'!
hasValue: aString
	^(self valueSlots select: [ :v | v contains: aString ])  isNotEmpty ! !

!SVO methodsFor: 'private' stamp: 'hk 1/8/2015 15:06'!
incrementVersion
	version := (self version asInteger +1) asString
		
	! !

!SVO methodsFor: 'protocol - testing' stamp: 'hk 1/23/2015 19:39'!
isAsvo
	^isAsvo ifNil: [ isAsvo := true ].
! !

!SVO methodsFor: 'file handling' stamp: 'hk 1/7/2015 13:57'!
logFileName
	^ self pName , '.log'! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
moveDown: aKey
	| i toMove size |
	i := slotSequence indexOf: aKey.
	toMove := slotSequence remove: aKey.
	size := slotSequence size.
	slotSequence add: toMove afterIndex: (size min: i ).
	self announcer announce: SlotsChanged new! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
moveUp: aKey
	| i toMove |
	i := slotSequence indexOf: aKey.
	toMove := slotSequence remove: aKey.
	slotSequence add: toMove beforeIndex: (1 max: i - 1).
	self announcer announce: SlotsChanged new! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
pName
	^pName ifNil: [ pName := 'XXX' asSymbol ] ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
pName: aString
	pName  := aString asSymbol! !

!SVO methodsFor: 'printing' stamp: 'hk 1/7/2015 13:57'!
print: aDict labelled: aName on: aStream indent: anInt

	aStream cr; tab: anInt; nextPutAll: aName. 
	aDict associationsDo: [ :a | aStream crtab; tab: anInt. a printOn: aStream ] ! !

!SVO methodsFor: 'printing' stamp: 'hk 1/8/2015 15:22'!
printHeaderOn: aStream indent: anInt

	aStream tab: anInt; nextPutAll:  self class name, ': ', self pName ; 
		cr; tab: anInt; nextPutAll:  'version ', self version  ; 
		cr; tab: anInt; nextPutAll:  'elder: ', self templateName;
		cr; tab: anInt; nextPutAll:  'elder version: ', self templateVersion;
		cr; tab: anInt; nextPutAll:  'entityElder: ', self elderName;
		cr; tab: anInt; nextPutAll:  'entityElder version: ', self elderVersion;
		cr; tab: anInt; nextPutAll:  'exemplars: ', self copies size printString
! !

!SVO methodsFor: 'printing' stamp: 'hk 1/7/2015 13:57'!
printOn: aStream
	self printOn: aStream indent: 0! !

!SVO methodsFor: 'printing' stamp: 'hk 1/21/2015 15:33'!
printOn: aStream indent: anInt

	self printHeaderOn: aStream indent: anInt.
	self print: self slots labelled: 'Slots: ' on: aStream indent: anInt.
	aStream cr; tab: anInt; nextPutAll: 'contained SPO: '; cr. 
	self svoSlots do: [ :v | v svo printOn: aStream indent: anInt +1] .
! !

!SVO methodsFor: 'printing' stamp: 'hk 1/7/2015 13:57'!
qualifiedName
	^self class name asString, ': ', self pName

		
	! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 1/7/2015 13:57'!
reOpen  
	self announcer announce: ReOpenFrame  new.
 ! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 13:57'!
redo
	self redoStack ifEmpty: [ ^self ].		"precondition"
	^self undoStack add: ( self redoStack removeLast redo)! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
redoStack
	^redoStack ifNil: [ redoStack := OrderedCollection new ]

		
	! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 1/26/2015 22:35'!
removeCopy: aPname
	"remove a SPO from a SPO's exemplars"
	| svo |
	svo := self class at: aPname .
	self copies removeKey: aPname.
	self class svos removeKey: aPname.
	self announcer announce: SlotsChanged new.
	svo delete.
	^svo! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
removeSlot: aKey 
	"answer the removed slot"
	| old |  
	slotSequence remove: aKey.
	old := self slots removeKey: aKey.
	self announcer announce: SlotsChanged new.
	^old

! !

!SVO methodsFor: 'private' stamp: 'hk 1/12/2015 17:19'!
resetVersion
	version := '0'! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 13:57'!
rollBack
	self undoStack reverseDo: [ :cmd | cmd undo ].
	self clearCommandStacks ! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/21/2015 15:48'!
save
	"save the SPO and increment the version "
	
	self incrementVersion.
	self clearCommandStacks.
	SvoStorage 
		store: self pName "storeString" isAsvo: self isAsvo to: self fileName;
		storeLog: pName, ' saved, version: ', self version isAsvo: self isAsvo .
	elder ifNotNil: [ self elder save ]! !

!SVO methodsFor: 'copying' stamp: 'hk 1/21/2015 15:33'!
setSlotFrames
	slots valuesDo: [ :v | v frame: self . 
						v isSvoSlot ifTrue: [ v svo elder: self ] .
						v isSvoList ifTrue: [ v list do: [ :e | e elder: self ] ] ].
	! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/30/2015 13:12'!
slotAt: aKey
	^ self slots at: aKey ifAbsent: [ nil ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slotSequence
	^slotSequence ifNil:  [slotSequence := OrderedCollection new ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slotSequence: aColl
	slotSequence := aColl! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slotSize
	^ slots size! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slots
	^ slots ifNil: [ slots := Dictionary new ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slots: aDict
	slots := aDict
	
	! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 2/2/2015 18:50'!
slotsAsCollOfPairs
	"answer the slots as a CollectionOfPairs that understand pairsDo: "
	
	| coll|
	coll := OrderedCollection new.
	self slotSequence do: [ :e | | v | 
		v := slots at: e. 
		coll add: e asSymbol . 
		coll add: (CommonSlotUI  on: v type: v uiClass)  ].
	^coll! !

!SVO methodsFor: 'copying' stamp: 'hk 1/8/2015 15:33'!
slotsCopy
	| c |
	c := Dictionary new.
	self slots keysAndValuesDo: [ :k :v | c at: k put: v copy ].  
	^c! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/20/2015 18:00'!
slotsDo: aBlock
	self slotSequence do: [ :k |  aBlock value: (self slots at: k) ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/14/2015 12:03'!
svoDynamicListSlots
	^ self slots select: [ :v | v isSvoDynamicList ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/14/2015 12:03'!
svoListSlots
	^ self slots select: [ :v | v isSvoList ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/14/2015 13:25'!
svoSlots
	^ self slots select: [ :v | v isSvoSlot ]! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
template
	^template ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
template:  aSvo
	template := aSvo! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:20'!
templateName
	^self template ifNil: [ '' ] ifNotNil: [ self template pName ] ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:20'!
templateVersion
	^self template ifNil: [ '' ] ifNotNil: [self template version ]
! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 13:57'!
undo
	self undoStack ifEmpty: [ ^self ].		"precondition"
	^self redoStack add: ( self undoStack removeLast undo)! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
undoStack
	^undoStack ifNil: [ undoStack := OrderedCollection new ]

		
	! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
valueSlots
	^ self slots select: [ :v | v isValueSlot ]! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/12/2015 17:19'!
version
	"answer the version string starting at '0' "
	^version ifNil: [ self resetVersion. version ] ! !

SVO subclass: #VO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!VO commentStamp: 'hk 1/14/2015 11:21' prior: 0!
I am a Value Object. My slot types are the inherited ones.

!

Object subclass: #SvoStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!SvoStorage commentStamp: 'hk 11/17/2014 19:35' prior: 0!
A SPOStorage represents the interface to any storage.
!

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:53'!
aFilepattern
	^'*.asvo'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:52'!
aFiletype
	^'asvo'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:53'!
dFilename
	^'*.dsvo'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:53'!
dFilepattern
	^'*.dsvo'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:52'!
dFiletype
	^'dsvo'! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 11/24/2014 22:31'!
delete: aPattern inDir: aDir

	((self storeReference: aDir) filesMatching: aPattern ) 
		do: [ :f | f delete ]! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:54'!
deleteAllAsvo
	"use with care	SPO deleteAllAspo"

	self delete: self aFilepattern inDir: self aFiletype! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:55'!
deleteAllDsvo
	"use with care	SVO deleteAllAsvo"

	self delete: self dFilepattern inDir: self dFiletype! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:45'!
deleteAllFiles
	"use with care	SpoStorage deleteAllFiles"

	self deleteAllInAspo ; deleteAllInDsvo ! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:55'!
deleteAllInAspo   
	self delete: '*.*' inDir: self aFiletype ! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:55'!
deleteAllInDsvo   
	self delete: '*.*' inDir: self dFiletype! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 11/17/2014 21:03'!
logFileExt
^ '.log'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:46'!
readAll
	"read all spo files -  SPO readAll"
	
	self readAllAsvo ; readAllDsvo ! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:56'!
readAllAsvo
	"read all aspo files ASPO readAllAspo"

	self readFilesMatching:  self aFilepattern  fromDir:  self aFiletype 
		! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:57'!
readAllDsvo
	"read all dsvo files -  SVO readAllDsvo"
	
	self readFilesMatching:  self dFilepattern fromDir:  self dFiletype 
		! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:57'!
readAsvo: fileName 
	^self readSvo: fileName type: self aFiletype ! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:57'!
readDsvo: fileName 
	^self readSvo: fileName type: self dFiletype ! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 1/21/2015 15:50'!
readFilesMatching: aPattern fromDir: aDir
	"read all asvo files ASVO readAllAspo"
	
	((self storeReference: aDir) filesMatching:  aPattern) do: 
		[ :f |  |stream svo|
		stream := f readStream readOnly. 
		svo := CodeImporter evaluateFileStream: stream.
"		SVO addIfCurrent: svo.				noch zu klären !!!!!!!!!!!!
"		stream close. ]! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 1/21/2015 15:49'!
readSvo: fileName type: typeString
	| svo |
	((self storeReference: typeString ) / fileName ) 
		readStreamDo: [ :stream | 
			svo := CodeImporter evaluateFileStream: stream .
			VO addSvo: svo ].
	^svo! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:57'!
saveAll
	"handle with care  	SVO saveAll"
	
	VO svos do: [ :svo | svo save   ]! !

!SvoStorage class methodsFor: 'interface' stamp: 'hk 1/21/2015 15:58'!
store: storeString isAsvo: aBoolean to: fileName
	"take the storeString and write it into file fileName"
	
	aBoolean 
		ifTrue:  [ self store: self aFiletype  svo: storeString to: fileName ]
		ifFalse: [ self store: self dFiletype  svo: storeString to: fileName ]

! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 1/21/2015 15:47'!
store: fileType svo: aString to: fileName
	((self storeReference: fileType) / fileName ) 
		ensureDelete;
		writeStreamDo: [ :stream | stream nextPutAll: aString]! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 11/24/2014 21:25'!
storeFor: fileType log: aLine
	"file will be appended"

	(self storeReference: fileType) / (fileType , self logFileExt)
		writeStreamDo: [ :stream | stream setToEnd; cr; nextPutAll: DateAndTime current printString; nextPut: $ ; nextPutAll: aLine]! !

!SvoStorage class methodsFor: 'interface' stamp: 'hk 1/21/2015 15:58'!
storeLog: logLine isAsvo: aBoolean
	"write the logLine "
	aBoolean 
		ifTrue:  [ self storeFor: self aFiletype  log: logLine ]
		ifFalse: [ self storeFor: self dFiletype log: logLine ]
	! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 11/17/2014 19:48'!
storeReference: dirName
	"answer my store fileReference"   
	| storeReference |
	storeReference :=  FileSystem disk workingDirectory / dirName.
	storeReference isDirectory ifFalse: [storeReference createDirectory] .
	^storeReference! !
